---@enum EB1RabbitHoleInteractionReason
local EB1RabbitHoleInteractionReason = {
    System = 0,
    UserInput = 1,
    FinishRabbitHoleAction = 2,
    Cheat = 3,
    TimeTask = 4,
    EB1RabbitHoleInteractionReason_MAX = 5,
}

---@enum EB1SocialEventActionMemberResult
local EB1SocialEventActionMemberResult = {
    Waiting = 0,
    Playing = 1,
    Complete = 2,
    Fail = 3,
    EB1SocialEventActionMemberResult_MAX = 4,
}

---@enum EB2ActionState
local EB2ActionState = {
    Invalid = 0,
    PostInit = 1,
    Playing = 2,
    TryFinish = 3,
    Finished = 4,
    EB2ActionState_MAX = 5,
}

---@enum EB2ActionVectorParamType
local EB2ActionVectorParamType = {
    Invalid = 0,
    Destination = 1,
    Max = 2,
}

---@enum EB2AutonomyState
local EB2AutonomyState = {
    Invalid = 0,
    StandBy = 1,
    CollectInteractions_AOI = 2,
    CollectInteractions_InProcess = 3,
    CollectInteractions_Site = 4,
    Finish = 5,
    EB2AutonomyState_MAX = 6,
}

---@enum EB2AutonomyWaitReason
local EB2AutonomyWaitReason = {
    Invalid = 0,
    None = 1,
    VisitSchedule = 2,
    Feedback = 3,
    CantInteractable = 4,
    DisableAutonomy = 5,
    EB2AutonomyWaitReason_MAX = 6,
}

---@enum EB2AvoidanceState
local EB2AvoidanceState = {
    Clean = 0,
    Avoid = 1,
    Return = 2,
    ForceReturn = 3,
    EB2AvoidanceState_MAX = 4,
}

---@enum EB2CharacterMoveReason
local EB2CharacterMoveReason = {
    Invalid = 0,
    StartPoint = 1,
    MotionWarping = 2,
    PathFollowing = 3,
    RootMotion = 4,
    WASD = 5,
    SafeLocation = 6,
    Teleport = 7,
    SetByB1Adjust = 8,
    SetByB1Sync = 9,
    SetByCharacter = 10,
    Ladder = 11,
    Attached = 12,
    EB2CharacterMoveReason_MAX = 13,
}

---@enum EB2CharacterStatePriority
local EB2CharacterStatePriority = {
    NORMAL = 0,
    AUTONOMY = 1,
    Timeline = 2,
    COOP = 3,
    ForceGoHome = 4,
    VehicleRiding = 5,
    Carried = 6,
    SocialEventScenario = 7,
    EB2CharacterStatePriority_MAX = 8,
}

---@enum EB2CityGraphInvalidReason
local EB2CityGraphInvalidReason = {
    None = 1,
    SystemError = 2,
    InvalidIndex = 3,
    RemovedLaneOrRoad = 4,
    AddedLaneOrRoad = 5,
    Max = 6,
}

---@enum EB2ComponentType
local EB2ComponentType = {
    Invalid = 0,
    Stat = 1,
    Modifier = 2,
    Interaction = 3,
    Autonomy = 4,
    Bio = 5,
    SitePathFinding = 6,
    PathFollowing = 7,
    CharacterMove = 8,
    Buff = 9,
    Life = 10,
    Emotion = 11,
    State = 12,
    Job = 13,
    Company = 14,
    Timeline = 15,
    Slot = 16,
    ObjectGrouping = 17,
    Posture = 18,
    Currency = 19,
    Howling = 20,
    VehiclePerception = 21,
    VehicleBehaviorDecision = 22,
    VehicleMovement = 23,
    VehicleLaneChange = 24,
    VehicleNavigation = 25,
    VehicleSimpleNavigation = 26,
    VehicleCollision = 27,
    DrivableVehicle = 28,
    Coop = 29,
    Relationship = 30,
    BoxComponent = 31,
    HouseholdMonitoring = 32,
    Appearance = 33,
    Trait = 34,
    Skill = 35,
    MobileMessage = 36,
    SubAction = 37,
    Move = 38,
    Dusty = 39,
    ObjectWeathering = 40,
    Dream = 41,
    Preference = 42,
    Hope = 43,
    Ambition = 44,
    Perspective = 45,
    Mission = 46,
    InteractionTracking = 47,
    Instinct = 48,
    Tax = 49,
    AttachMesh = 50,
    Test = 51,
    Stuck = 52,
    Talk = 53,
    Crafting = 54,
    Quest = 55,
    RabbitHole = 56,
    Num = 57,
    EB2ComponentType_MAX = 58,
}

---@enum EB2ContinueCraftingMethod
local EB2ContinueCraftingMethod = {
    Invalid = 0,
    CrafingObject = 1,
    CraftingSlot = 2,
    EB2ContinueCraftingMethod_MAX = 3,
}

---@enum EB2EntityDestroyReason
local EB2EntityDestroyReason = {
    Invalid = 0,
    InitEntitySystem = 1,
    Death = 2,
    Completion = 3,
    Input = 4,
    Cheat = 5,
    Pickup = 6,
    DestroyCradleObject = 7,
    DestroyCarriableObject = 8,
    PutdownActionFinishObject = 9,
    RemovedHouseholdAllMembers = 10,
    BuildMode = 11,
    DustyClean = 12,
    UnregisterVehicle = 13,
    VehicleOwnerNotFound = 14,
    VehicleAccident = 15,
    NewVehicleSpawn = 16,
    OverlapWithTeleportVehicle = 17,
    DensityControl = 18,
    ThrowAway = 19,
    NotFoundCradlePos_DEPRECATED = 20,
    SaleObject = 21,
    NotFoundSootPos_DEPRECATED = 22,
    NotFoundGiftPos = 23,
    RemoveGift = 24,
    FireExtinguish = 25,
    TemporaryEntityForCalculateCondition = 26,
    Script = 27,
    ResetSite = 28,
    InvalidCityGraph = 29,
    PopulationSystem = 30,
    ClearCharacteState = 31,
    ForcedSaleBySeizure = 32,
    BuildModeByFakeObject = 33,
    DuplicateHowling = 34,
    VehicleOnCrosswalk = 35,
    PocketMarket = 36,
    PlayerGetInVehicle = 37,
    PlayerAutoDriving = 38,
    RequestRemoveHousehold = 39,
    EB2EntityDestroyReason_MAX = 40,
}

---@enum EB2EntityState
local EB2EntityState = {
    Invalid = 0,
    Simulate = 1,
    GameSpawned = 2,
    Death = 4,
    TimelineSimulateOnly = 8,
    GhostSimulate = 16,
    Active = 3,
    Freeze = 0,
    NpcWait = 8,
    Ghost = 23,
    EB2EntityState_MAX = 24,
}

---@enum EB2EntityStateChangeReason
local EB2EntityStateChangeReason = {
    Invalid = 0,
    Initialize = 1,
    Destroy = 2,
    Death = 3,
    NpcTimeline = 4,
    PutIn = 5,
    PutOut = 6,
    RequestSpawn = 7,
    Coop = 8,
    Cheat = 9,
    Subway = 10,
    EvictSite = 11,
    MoveSite = 12,
    Use = 13,
    BuildMode = 14,
    VehicleAccidentHowling = 15,
    EventCrowdFinishInteraction = 16,
    GiftSuccess = 17,
    DivorceCharacter = 18,
    SiteEvent = 19,
    Service = 20,
    Salable = 21,
    SafeControl = 22,
    EB2EntityStateChangeReason_MAX = 23,
}

---@enum EB2InteractionFailReason
local EB2InteractionFailReason = {
    None = 0,
    InvalidSelectedSequence = 1,
    WalkToFail = 2,
    NotFoundSlot = 3,
    NotFoundSelf = 4,
    NotFoundTarget = 5,
    NotFoundCityGraphNearestPoint = 6,
    NotFoundCityGraphPoint = 7,
    NotFoundcityGraphPath = 8,
    NotFoundPutDownLocation = 9,
    NotFoundSiteSpawnLocation = 10,
    NotPossessEntity = 11,
    TryStartFail = 12,
    CheckConditionFail = 13,
    CantOccupyObjectSlot = 14,
    CantOccupyInteractionSlot = 15,
    CantOccupyObjectSlotInvalidGrabObject = 16,
    InvalidCity = 17,
    InvalidSite = 18,
    InvalidSelfEntity = 19,
    InvalidSelfLocation = 20,
    InvalidTargetEntity = 21,
    InvalidTargetLocation = 22,
    InvalidTargetSlot = 23,
    FailedFindPath = 24,
    InvalidAnimId = 25,
    InvalidAnimMontage = 26,
    InvalidGender = 27,
    InvalidAge = 28,
    InvalidCoopId = 29,
    InvalidCoopType = 30,
    InvalidOwnedVehicle = 31,
    FailedRequestCoop = 32,
    FailedParseCoopContext = 33,
    FailedDataRead = 34,
    CoopCanceled = 35,
    InvalidGrab = 36,
    InvalidBookId = 37,
    AlreadyInVehicle = 38,
    NotInVehicle = 39,
    HasPassengerInVehicle = 40,
    FailedParseActionContext = 41,
    FailedActionCondition = 42,
    FailedPlayLevelSequence = 43,
    InvalidPostureId = 44,
    RabbitHoleTimePassed = 45,
    InvalidTargetFoodEntity = 46,
    InvalidFoodId = 47,
    FailedFindSpawner = 48,
    InvalidObjectData = 49,
    CantPutInInventory = 50,
    InvalidRecipeId = 51,
    InvalidInteractionBagId = 52,
    NotFoundCraftingComponent = 53,
    InvalidCraftingContinueMethod = 54,
    InvalidCraftObject = 55,
    InvalidCraftGameObjectStatComponent = 56,
    RabbitHoleOverwrite = 57,
    InvalidSaleableObject = 58,
    InvalidSystem = 59,
    AutomationTest = 60,
    InvalidMotionIndex = 61,
    FailedSendPacket = 62,
    InvalidComponents = 63,
    GhostDenied = 64,
    InvalidPlayingComponentName = 65,
    EB2InteractionFailReason_MAX = 66,
}

---@enum EB2InteractionResult
local EB2InteractionResult = {
    Invalid = 0,
    Canceled = 1,
    Failed = 2,
    Finish = 3,
    EB2InteractionResult_MAX = 4,
}

---@enum EB2LadderAnimType
local EB2LadderAnimType = {
    Invalid = 0,
    Enter = 1,
    Exit = 2,
    EB2LadderAnimType_MAX = 3,
}

---@enum EB2ManagerType
local EB2ManagerType = {
    Time = 0,
    AsyncLoad = 1,
    TimeTask = 2,
    Weather = 3,
    Site = 4,
    FamilyTree = 5,
    Spawner = 6,
    Entity = 7,
    KarmaReport = 8,
    WorldMission = 9,
    Gift = 10,
    Rumor = 11,
    Avoidance = 12,
    WorldEvent = 13,
    Talk = 14,
    CityEdit = 15,
    CityGraph = 16,
    SiteEvent = 17,
    DLDSLM = 18,
    ChoiceCard = 19,
    PocketMarket = 20,
    GeneratedMotionSlot = 21,
    Service = 22,
    Meeting = 23,
    Timeline = 24,
    Debug = 25,
    Max = 26,
}

---@enum EB2MeetingCheckResult
local EB2MeetingCheckResult = {
    Invalid = 0,
    Success = 1,
    NotValidCharacter = 2,
    NotValidTimeline = 3,
    NotValidCarried = 4,
    NotValidMeetingId = 5,
    DoingOverrideSchedule = 6,
    CarriedBaby = 7,
    NotValidBio = 8,
    RabbitHole = 9,
    Death = 10,
    Ghost = 11,
    Fire = 12,
    Baby = 13,
    CheckCondtionFail = 14,
    EB2MeetingCheckResult_MAX = 15,
}

---@enum EB2MeetingMatchingStep
local EB2MeetingMatchingStep = {
    Invalid = 0,
    Ready = 1,
    CollectMeetingAbleCharacters = 2,
    PickMeetingCharacter = 3,
    MeetingCharacters = 4,
    Complete = 5,
    EB2MeetingMatchingStep_MAX = 6,
}

---@enum EB2MontageState
local EB2MontageState = {
    Invalid = 0,
    Playing = 1,
    BlendOut = 2,
    Terminated = 3,
    EB2MontageState_MAX = 4,
}

---@enum EB2MontageSubStepResult
local EB2MontageSubStepResult = {
    Invalid = 0,
    Moved = 1,
    NotMoved = 2,
    InvalidSection = 3,
    InvalidMontage = 4,
    EB2MontageSubStepResult_MAX = 5,
}

---@enum EB2MoveOverState
local EB2MoveOverState = {
    InActive = 0,
    BeforeFirstCheck = 1,
    FirstCheckCompleted = 2,
    FinalCheckCompleted = 3,
    Fail = 4,
    Complete = 5,
    EB2MoveOverState_MAX = 6,
}

---@enum EB2PlayerState
local EB2PlayerState = {
    Invalid = 0,
    Waiting = 1,
    StandBy = 2,
    Playing = 3,
    EB2PlayerState_MAX = 4,
}

---@enum EB2PortalPhase
local EB2PortalPhase = {
    Ready = 0,
    SyncLocation = 1,
    PlayEnterAnim = 2,
    LoadAndWarp = 3,
    PlayExitAnim = 4,
    EB2PortalPhase_MAX = 5,
}

---@enum EB2PutDownMethod
local EB2PutDownMethod = {
    Invalid = 0,
    TargetObject = 1,
    Inventory = 2,
    Floor = 3,
    Destroy = 4,
    EB2PutDownMethod_MAX = 5,
}

---@enum EB2RequestPathRetryState
local EB2RequestPathRetryState = {
    None = 0,
    RestoreLocation = 1,
    WalkableLocation = 2,
    Max = 3,
}

---@enum EB2SimulationState
local EB2SimulationState = {
    Invalid = 0,
    Pause = 1,
    Play = 2,
    Finish = 3,
    EB2SimulationState_MAX = 4,
}

---@enum EB2SiteAreaUnit
local EB2SiteAreaUnit = {
    Object = 0,
    Grid = 1,
    EB2SiteAreaUnit_MAX = 2,
}

---@enum EB2StatPhaseType
local EB2StatPhaseType = {
    Normal = 0,
    Warning = 1,
    Dangerous = 2,
    EB2StatPhaseType_MAX = 3,
}

---@enum EB2StatType
local EB2StatType = {
    Invalid = 0,
    Motive = 1,
    Hobby = 2,
    Work = 3,
    Visitor = 4,
    Weathering = 5,
    EB2StatType_MAX = 6,
}

---@enum EB2SubActionAnimState
local EB2SubActionAnimState = {
    None = 0,
    Loading = 1,
    Playing = 2,
    Ended = 3,
    EB2SubActionAnimState_MAX = 4,
}

---@enum EB2TalkAnimType
local EB2TalkAnimType = {
    Invalid = 0,
    FullBody = 1,
    UpperBody = 2,
    FaceOnly = 3,
    EB2TalkAnimType_MAX = 4,
}

---@enum EB2TalkBehaviorType
local EB2TalkBehaviorType = {
    Invalid = 0,
    Positive = 1,
    Negative = 2,
    Normal = 3,
    Max = 4,
}

---@enum EB2TalkCharacterState
local EB2TalkCharacterState = {
    None = 0,
    Positioning = 1,
    WaitingPositioning = 2,
    Talking = 3,
    WaitingNextSequence = 4,
    EB2TalkCharacterState_MAX = 5,
}

---@enum EB2TalkRole
local EB2TalkRole = {
    Invalid = 0,
    Speaker = 1,
    Listener = 2,
    Spectator = 3,
    Quit = 4,
    EB2TalkRole_MAX = 5,
}

---@enum EB2TalkType
local EB2TalkType = {
    Invalid = 0,
    FixedStandFirst = 1,
    UnfixedFirst = 2,
    Random = 3,
    EB2TalkType_MAX = 4,
}

---@enum EB2TimeTaskType
local EB2TimeTaskType = {
    Invalid = 0,
    RescuePlayer = 1,
    SendGiftAtSite = 2,
    AutonomyCrowd = 3,
    SendPreferenceAlert = 4,
    SendCustomMobileMessage = 5,
    DistributeRunScript = 6,
    StartSiteEvent = 7,
    FinishSiteEvent = 8,
    TeleportSiteEvent = 9,
    SiteActionTrigger = 10,
    DelayRabbitHoleInteraction = 11,
    FlushTalkInstance = 12,
    TryProceedTalkInstance = 13,
    LevelUpSkill = 14,
    RequestDetermine = 15,
    TryNextChoiceCard = 16,
    SocialEventAddInteractionBag = 17,
    CheckRumorLifeTime = 18,
    AddHouseholdMonitoringNotification = 19,
    BabyNeglectWarningMessage = 20,
    RequestBabysitterService = 21,
    RefreshSiteEventActionState = 22,
    OverrideMeshSpawner = 23,
    SkipMoveWithVehicle = 24,
    CheatStartAging = 25,
    CheatUnlockProfileData = 26,
    EB2TimeTaskType_MAX = 27,
}

---@enum EB2TriggerType
local EB2TriggerType = {
    None = 0,
    Time = 1,
    EB2TriggerType_MAX = 2,
}

---@enum EB2WalkToState
local EB2WalkToState = {
    None = 0,
    PathFollowing = 1,
    MotionWarping = 2,
    Finished = 3,
    EB2WalkToState_MAX = 4,
}

