---@enum EAnim_RootYawOffsetMode
local EAnim_RootYawOffsetMode = {
    BlendOut = 0,
    Hold = 1,
    Accumulate = 2,
    EAnim_MAX = 3,
}

---@enum EAnim_StateSequence
local EAnim_StateSequence = {
    None = 0,
    Start = 1,
    Cycle = 2,
    Turn = 3,
    Idle = 4,
    EAnim_MAX = 5,
}

---@enum EB13DPrinterEntryScene
local EB13DPrinterEntryScene = {
    None = 0,
    BuildMode = 1,
    CharacterCustomizeMode = 2,
    EB13DPrinterEntryScene_MAX = 3,
}

---@enum EB1AILoadingScreenMode
local EB1AILoadingScreenMode = {
    Texture = 0,
    Motion = 1,
    EB1AILoadingScreenMode_MAX = 2,
}

---@enum EB1AITextureScalarParameterType
local EB1AITextureScalarParameterType = {
    Intensity = 0,
    Scale = 1,
    Roughness = 2,
    OffsetX = 3,
    OffsetY = 4,
    Max = 255,
}

---@enum EB1AmbitionSelectState
local EB1AmbitionSelectState = {
    UnSelect = 0,
    UnAble = 1,
    Select = 2,
    EB1AmbitionSelectState_MAX = 3,
}

---@enum EB1AppearanceConfigurationType
local EB1AppearanceConfigurationType = {
    None = 0,
    UpperGarments = 1,
    LowerGarments = 2,
    FashionAccessory = 4,
    Shoes = 8,
    OnePiece = 16,
    OuterGarments = 32,
    InnerUnder = 64,
    CustomGarments = 128,
    Hat = 256,
    ClothingPreset = 511,
    FacePreset = 512,
    AppearanceAllPreset = 1023,
    EB1AppearanceConfigurationType_MAX = 1024,
}

---@enum EB1ApperanceFilter
local EB1ApperanceFilter = {
    None = 0,
    Appearance = 1,
    Face = 2,
    Costume = 4,
    AppearanceAndFace = 3,
    AppearanceAndCostume = 5,
    FaceAndCostume = 6,
    All = 7,
    EB1ApperanceFilter_MAX = 8,
}

---@enum EB1ApperanceMeshState
local EB1ApperanceMeshState = {
    None = 0,
    RefreshBody = 1,
    RefreshHead = 2,
    RefreshHair = 4,
    RefreshFaceHair = 8,
    RefreshGarments = 16,
    RefreshAlls = 31,
    ReadyBodyStart = 32,
    ReadyHeadStart = 64,
    ReadyHairStart = 128,
    ReadyFaceHairStart = 256,
    ReadyGarmentsStart = 512,
    ReadyStartAlls = 992,
    ReadyBodyDone = 1024,
    ReadyHeadDone = 2048,
    ReadyHairDone = 4096,
    ReadyFaceHairDone = 8192,
    ReadyGarmentsDone = 16384,
    ReadyDoneAlls = 31744,
    MergedMeshBodyDone = 32768,
    MergedMeshHeadDone = 65536,
    MergedMeshHairDone = 131072,
    MergedMeshFaceHairDone = 262144,
    MergedMeshGarmentsDone = 524288,
    MergedMeshBodyValid = 33825,
    MergedMeshHeadValid = 67650,
    MergedMeshFaceHairValid = 270600,
    MergedMeshGarmentsValid = 541200,
    SetMeshBody = 1048576,
    SetMeshHead = 2097152,
    SetMeshHair = 4194304,
    SetMeshFaceHair = 8388608,
    SetMeshGarments = 16777216,
    SetMeshAlls = 32505856,
    SetAlls = 32538623,
    EB1ApperanceMeshState_MAX = 32538624,
}

---@enum EB1AssetCategory
local EB1AssetCategory = {
    Asset = 0,
    Tops = 1,
    Outerwear = 2,
    Sets = 3,
    Bottoms = 4,
    Accessories = 5,
    Shoes = 6,
    Underwear = 7,
    EB1AssetCategory_MAX = 8,
}

---@enum EB1AsyncLoadContent
local EB1AsyncLoadContent = {
    ChangeBodyMesh = 0,
    ChangeHeadMesh = 1,
    ChangeHairMesh = 2,
    ChangeGarmentMesh = 3,
    ChangeIrisMesh = 4,
    ChangeMakeup = 5,
    Max = 6,
}

---@enum EB1AvoidanceState
local EB1AvoidanceState = {
    Clean = 0,
    Avoid = 1,
    Return = 2,
    ForceReturn = 3,
    EB1AvoidanceState_MAX = 4,
}

---@enum EB1BoneModificationMode
local EB1BoneModificationMode = {
    Ignore = 0,
    Replace = 1,
    Additive = 2,
    EB1BoneModificationMode_MAX = 3,
}

---@enum EB1BuildDirectionType
local EB1BuildDirectionType = {
    None = 0,
    Forward = 1,
    Backward = 2,
    Left = 3,
    Right = 4,
    Up = 5,
    Down = 6,
    LeftTop = 7,
    RightTop = 8,
    LeftBottom = 9,
    RightBottom = 10,
    EB1BuildDirectionType_MAX = 11,
}

---@enum EB1BuildKeyGuideViewFlag
local EB1BuildKeyGuideViewFlag = {
    None = 0,
    Shift = 1,
    Rotate = 2,
    Esc = 4,
    Del = 8,
    Desc = 16,
    WallDesc = 32,
    Alt = 64,
    Default = 79,
    Default_WithDesc = 95,
    Door = 95,
    Wall = 4,
    Wall_WithDesc = 36,
    EB1BuildKeyGuideViewFlag_MAX = 96,
}

---@enum EB1CameraCollisionType
local EB1CameraCollisionType = {
    None = 0,
    StaticMesh = 1,
    InstancedStaticMesh = 2,
    CollisionMesh = 3,
    ObjectMesh = 4,
    EB1CameraCollisionType_MAX = 5,
}

---@enum EB1CameraTransitionState
local EB1CameraTransitionState = {
    Invalid = 0,
    PrevBlendOut = 1,
    CurrentBlendIn = 2,
    MapMode = 3,
    CityEditMode = 4,
    CurrentBlendOut = 5,
    StreamingSourceLoading = 6,
    PrevBlendIn = 7,
    CustomCameraBlendStart = 8,
    CustomCameraBlendOut = 9,
    ChangeCameraPosition = 10,
    EB1CameraTransitionState_MAX = 11,
}

---@enum EB1CaptureCameraType
local EB1CaptureCameraType = {
    None = 0,
    Room = 1,
    Object = 2,
    Site = 3,
    EB1CaptureCameraType_MAX = 4,
}

---@enum EB1CharacterCustomizationAccessoryCategory
local EB1CharacterCustomizationAccessoryCategory = {
    None = 0,
    Hat = 1,
    Eyewear = 2,
    Necklace = 3,
    Earring = 4,
    HairAccessory = 5,
    Nail = 6,
    Bracelet = 7,
    Ring = 8,
    Piercing = 9,
    Custom = 10,
    EB1CharacterCustomizationAccessoryCategory_MAX = 11,
}

---@enum EB1CharacterCustomizationAiTextureValueType
local EB1CharacterCustomizationAiTextureValueType = {
    None = 0,
    Intensity = 1,
    Roughness = 2,
    Scale = 3,
    OffsetX = 4,
    OffsetY = 5,
    EB1CharacterCustomizationAiTextureValueType_MAX = 6,
}

---@enum EB1CharacterCustomizationBodyCategory
local EB1CharacterCustomizationBodyCategory = {
    None = 0,
    Preset = 1,
    Weight = 2,
    BodyHair = 3,
    EB1CharacterCustomizationBodyCategory_MAX = 4,
}

---@enum EB1CharacterCustomizationFaceCategory
local EB1CharacterCustomizationFaceCategory = {
    None = 0,
    Face = 1,
    Makeup = 2,
    Hair = 3,
    Skin = 4,
    SkinFeatures = 5,
    Eyes = 6,
    EB1CharacterCustomizationFaceCategory_MAX = 7,
}

---@enum EB1CharacterNameFormatOption
local EB1CharacterNameFormatOption = {
    FollowLanguage = 0,
    FollowCity = 1,
    FirstNameLastName = 2,
    LastNameFirstName = 3,
    Max = 4,
}

---@enum EB1CharacterStatePriority
local EB1CharacterStatePriority = {
    NORMAL = 0,
    AUTONOMY = 1,
    SCHEDULE = 2,
    COOP = 3,
    EB1CharacterStatePriority_MAX = 4,
}

---@enum EB1CinemaCharacterType
local EB1CinemaCharacterType = {
    None = 0,
    Player = 1,
    Target = 2,
    EB1CinemaCharacterType_MAX = 3,
}

---@enum EB1CloseUpFocusType
local EB1CloseUpFocusType = {
    Default = 0,
    Face = 1,
    Hand = 2,
    Body = 3,
    Full = 4,
    Accessory = 5,
    Wrist = 6,
    End = 7,
    EB1CloseUpFocusType_MAX = 8,
}

---@enum EB1ColorPickerPopupType
local EB1ColorPickerPopupType = {
    None = 0,
    Skin = 1,
    BodyHair = 2,
    CharacterCustomizeStudio = 3,
    EB1ColorPickerPopupType_MAX = 4,
}

---@enum EB1CommonFilterColorType
local EB1CommonFilterColorType = {
    White = 0,
    Black = 1,
    EB1CommonFilterColorType_MAX = 2,
}

---@enum EB1CraftingNamingInvalidReason
local EB1CraftingNamingInvalidReason = {
    None = 0,
    EmptyText = 1,
    MaxLengthOverText = 2,
    EB1CraftingNamingInvalidReason_MAX = 3,
}

---@enum EB1CurrencyDisplayMode
local EB1CurrencyDisplayMode = {
    Currency = 0,
    Infinite = 1,
    EB1CurrencyDisplayMode_MAX = 2,
}

---@enum EB1CurrencyWidgetType
local EB1CurrencyWidgetType = {
    Manually = 0,
    DisplayAmountCharacterOwns = 1,
    EB1CurrencyWidgetType_MAX = 2,
}

---@enum EB1DLDRequestState
local EB1DLDRequestState = {
    Ready = 0,
    PopUp = 1,
    Load = 2,
    Request = 3,
    EB1DLDRequestState_MAX = 4,
}

---@enum EB1DebugEntityType
local EB1DebugEntityType = {
    UniqueNpc = 0,
    SiteRoleNpc = 1,
    CompanyRoleNpc = 2,
    Crowd = 3,
    Ghost = 4,
    EB1DebugEntityType_MAX = 5,
}

---@enum EB1DoorState
local EB1DoorState = {
    Stop = 0,
    Opening = 1,
    Closing = 2,
    EB1DoorState_MAX = 3,
}

---@enum EB1EnvironmentEditSubTabType
local EB1EnvironmentEditSubTabType = {
    None = 0,
    Img = 1,
    Video = 2,
    EB1EnvironmentEditSubTabType_MAX = 3,
}

---@enum EB1EnvironmentEditType
local EB1EnvironmentEditType = {
    None = 0,
    Sign = 1,
    CityBalance = 2,
    Tree = 3,
    Grass = 4,
    Animal = 5,
    Crowd = 6,
    Decoration = 7,
    SpecialEffect = 8,
    EB1EnvironmentEditType_MAX = 9,
}

---@enum EB1FamilyDirection
local EB1FamilyDirection = {
    Left = 0,
    Right = 1,
    Center = 2,
    EB1FamilyDirection_MAX = 3,
}

---@enum EB1FamilyMoveFailReason
local EB1FamilyMoveFailReason = {
    None = 0,
    InvalidEntity = 1,
    HasBaby = 2,
    EB1FamilyMoveFailReason_MAX = 3,
}

---@enum EB1FamilyMoveLockedReason
local EB1FamilyMoveLockedReason = {
    Invalid = 0,
    PlayingZoi = 1,
    MarriedZoi = 2,
    GrabbedBaby = 3,
    GrabbingBaby = 4,
    BabyZoi = 5,
    EB1FamilyMoveLockedReason_MAX = 6,
}

---@enum EB1FamilyMoveWidgetDescription
local EB1FamilyMoveWidgetDescription = {
    ShowOption = 0,
    EmptyFurniture = 1,
    EmptySite = 2,
    EB1FamilyMoveWidgetDescription_MAX = 3,
}

---@enum EB1FamilyTreeRelationType
local EB1FamilyTreeRelationType = {
    None = 0,
    Housemate = 1,
    MarriedCouple = 2,
    Parent = 3,
    Child = 4,
    Sibling = 5,
    GrandParent = 6,
    GrandChild = 7,
    Ancestor = 8,
    Descendant = 9,
    EB1FamilyTreeRelationType_MAX = 10,
}

---@enum EB1FireworksLoopState
local EB1FireworksLoopState = {
    Once = 0,
    Infinite = 1,
    EB1FireworksLoopState_MAX = 2,
}

---@enum EB1FramesPerSecondsThreshold
local EB1FramesPerSecondsThreshold = {
    Fps_40ms = 0,
    Fps_50ms = 1,
    Fps_60ms = 2,
    Fps_100ms = 3,
    Fps_150ms = 4,
    Fps_200ms = 5,
    Fps_300ms = 6,
    Fps_500ms = 7,
    Fps_1s = 8,
    Fps_3s = 9,
    Fps_5s = 10,
    MAX = 12,
}

---@enum EB1FurnitureBuildErrorType
local EB1FurnitureBuildErrorType = {
    None = 0,
    SystemError = 1,
    OutOfSiteArea = 2,
    OverlappedDoNotBuildBox = 3,
    OverlapObject = 4,
    OverlapWall = 5,
    VerticalWindowPlacementRule = 6,
    BorderWindowPlacementRule = 7,
    DoorToDoorTooClose = 8,
    OutOfRoom = 9,
    OverlappedDevLockedWall = 10,
    OverlappedCustomizeLockedWallFace = 11,
    WindowDecoNotEnoughWidth = 12,
    OverlappedCannotBuildWindowDeco = 13,
    InvalidPillarHeight = 14,
    CannotBuildInRoom = 15,
    OverlapMultipleWalls = 16,
    CanNotTransfromStairs = 17,
    CannotBuildGap = 18,
    DifferentFencesCannotIntersect = 19,
    CanNotPlaceOnHoleGrid = 20,
    CanNotPlaceOnSite = 21,
    NoCeil = 22,
    NoFloor = 23,
    NotEnoughHeight = 24,
    FloorLevelLimit = 25,
    EB1FurnitureBuildErrorType_MAX = 26,
}

---@enum EB1GameMenuMode
local EB1GameMenuMode = {
    Default = 0,
    Lobby = 1,
    EB1GameMenuMode_MAX = 2,
}

---@enum EB1GameObjectSoundCommandType
local EB1GameObjectSoundCommandType = {
    OneShot = 0,
    UniqueOncePlay = 1,
    Stop = 2,
    EB1GameObjectSoundCommandType_MAX = 3,
}

---@enum EB1GameObjectStateType
local EB1GameObjectStateType = {
    None = 0,
    Target = 1,
    Grab = 2,
    Self = 3,
    EB1GameObjectStateType_MAX = 4,
}

---@enum EB1ListScrollType
local EB1ListScrollType = {
    Default = 0,
    ByCustomGarmentName = 1,
    ById = 2,
    EB1ListScrollType_MAX = 3,
}

---@enum EB1LoadGameState
local EB1LoadGameState = {
    Continue = 0,
    NewGame = 1,
    EB1LoadGameState_MAX = 2,
}

---@enum EB1LoadType
local EB1LoadType = {
    None = 0,
    SiteManager = 1,
    Navigation = 2,
    FamilyManager = 3,
    RelationshipCrowdManage = 4,
    EntityManager = 5,
    EB1LoadType_MAX = 6,
}

---@enum EB1LoadingRequestType
local EB1LoadingRequestType = {
    Invalid = 0,
    InitializeSystem = 1,
    GridLoading = 2,
    WaitSecond = 3,
    DataLayer = 4,
    AsyncLoad = 5,
    Portrait = 6,
    PossessPawnSpawn = 7,
    EB1LoadingRequestType_MAX = 8,
}

---@enum EB1LocomotionState
local EB1LocomotionState = {
    Idle = 0,
    Walk = 1,
    Jog = 2,
    Animating = 3,
    EB1LocomotionState_MAX = 4,
}

---@enum EB1ManagerType
local EB1ManagerType = {
    Entity = 0,
    EntityDataCache = 1,
    Spawn = 2,
    FX = 3,
    UI = 4,
    Scene = 5,
    Time = 6,
    DataCache = 7,
    CustomizeData = 8,
    WidgetCustomization = 9,
    SaveDataEtc = 10,
    SaveLoad = 11,
    Site = 12,
    Household = 13,
    Popup = 14,
    AlertMessage = 15,
    Audio = 16,
    Weather = 17,
    World = 18,
    MaterialParameterCollection = 19,
    StableDiffusion = 20,
    InputSetting = 21,
    MobileMessage = 22,
    Animation = 23,
    LevelSequence = 24,
    UserCustomizedData = 25,
    SceneCapture = 26,
    DataLog = 27,
    TrafficLightVisualize = 28,
    WebSocket = 29,
    UserAccount = 30,
    VehicleRepresentation = 31,
    TemporaryFile = 32,
    IngameFirstStartFlow = 33,
    CharacterThumbnailCapture = 34,
    GPP = 35,
    GPPTelemetry = 36,
    Avoidance = 37,
    DLDFile = 38,
    WebGalleryFile = 39,
    ImageTo3DFile = 40,
    AsyncLoad = 41,
    DefaultBuildPreset = 42,
    DLDRequest = 43,
    PlayLog = 44,
    TraitSelection = 45,
    VehicleStation = 46,
    Visibility = 47,
    MyGallery = 48,
    GalleryRequest = 49,
    GeneratedMotion = 50,
    Max = 51,
}

---@enum EB1MotionGenerationEntryScene
local EB1MotionGenerationEntryScene = {
    InGame = 0,
    PhotoMode = 1,
    BuildMode = 2,
    Customize = 3,
    EB1MotionGenerationEntryScene_MAX = 4,
}

---@enum EB1MotionGenerationMode
local EB1MotionGenerationMode = {
    Invalid = 0,
    Video = 1,
    Image = 2,
    Text = 3,
    EB1MotionGenerationMode_MAX = 4,
}

---@enum EB1MyCompanyReputationBarFillType
local EB1MyCompanyReputationBarFillType = {
    BottomToTop = 0,
    TopToBottom = 1,
    EB1MyCompanyReputationBarFillType_MAX = 2,
}

---@enum EB1ObjectListMode
local EB1ObjectListMode = {
    None = 0,
    Preset = 1,
    Furniture = 2,
    Construct = 3,
    Inventory = 4,
    Making = 5,
    EB1ObjectListMode_MAX = 6,
}

---@enum EB1OptimizationMaterialType
local EB1OptimizationMaterialType = {
    None = 0,
    Standard_Garment = 1,
    Special_Garment = 2,
    HairCard = 4,
    EyeRefractive = 8,
    Garment = 3,
    Head = 8,
    EB1OptimizationMaterialType_MAX = 9,
}

---@enum EB1OscElementType
local EB1OscElementType = {
    OET_Int32 = 0,
    OET_Float = 1,
    OET_String = 2,
    OET_Blob = 3,
    OET_Bool = 4,
    OET_Nil = 5,
    OET_MAX = 6,
}

---@enum EB1PhotoModeCameraCaptureShotType
local EB1PhotoModeCameraCaptureShotType = {
    PhotoShot = 0,
    VideoShot = 1,
    EB1PhotoModeCameraCaptureShotType_MAX = 2,
}

---@enum EB1PhotoModeCameraPlayTimeOption
local EB1PhotoModeCameraPlayTimeOption = {
    None = 0,
    StopTime = 1,
    PlayTime = 2,
    EB1PhotoModeCameraPlayTimeOption_MAX = 3,
}

---@enum EB1PhotoModeCameraSettingType
local EB1PhotoModeCameraSettingType = {
    CamerSetting = 0,
    FliterSetting = 1,
    EB1PhotoModeCameraSettingType_MAX = 2,
}

---@enum EB1PhotoModeCameraState
local EB1PhotoModeCameraState = {
    Ready = 0,
    ConvertMode = 1,
    ResultConfirm = 2,
    EB1PhotoModeCameraState_MAX = 3,
}

---@enum EB1PhotoModeEntryScene
local EB1PhotoModeEntryScene = {
    InGame = 0,
    Studio = 1,
    Customize = 2,
    EB1PhotoModeEntryScene_MAX = 3,
}

---@enum EB1PhotoModeMotionSettingOption
local EB1PhotoModeMotionSettingOption = {
    FacialPose = 0,
    Pose = 1,
    EB1PhotoModeMotionSettingOption_MAX = 2,
}

---@enum EB1PhotoModeOptionListEntryType
local EB1PhotoModeOptionListEntryType = {
    None = 0,
    Crop = 1,
    Filter = 2,
    EB1PhotoModeOptionListEntryType_MAX = 3,
}

---@enum EB1PhotoModeWidgetActionType
local EB1PhotoModeWidgetActionType = {
    AlbumFolder_Open = 0,
    FacialCapture_Open = 1,
    CameraOptionWidget_Open = 2,
    CameraOptionWidget_ChangeSettingTab = 3,
    CameraOptionWidget_ChangeFilterTab = 4,
    CameraOptionWidget_Close = 5,
    PhotoTab_OnClicked = 6,
    VideoTab_OnClicked = 7,
    PlayTime_OnClicked = 8,
    PausedTime_OnClicked = 9,
    CropSettingWidget_Open = 10,
    CropSettingWidget_Close = 11,
    Common_CancleButton_OnClicked = 12,
    Common_SaveButton_OnClicked = 13,
    ViewChange_TopView = 14,
    ViewChange_Character = 15,
    PortraitMode_OnClicked = 16,
    LandscapeMode_OnClicked = 17,
    EB1PhotoModeWidgetActionType_MAX = 18,
}

---@enum EB1PillarObjectType
local EB1PillarObjectType = {
    None = 0,
    Pattern = 1,
    Plain = 2,
    EB1PillarObjectType_MAX = 3,
}

---@enum EB1PlayerActionQueueRemoveAreaWidget_State
local EB1PlayerActionQueueRemoveAreaWidget_State = {
    Close = 0,
    Open = 1,
    DragOver = 2,
    CancelWait = 3,
    EB1PlayerActionQueueRemoveAreaWidget_MAX = 4,
}

---@enum EB1PlayerDesirePhase
local EB1PlayerDesirePhase = {
    Normal = 0,
    Warning = 1,
    Dangerous = 2,
    EB1PlayerDesirePhase_MAX = 3,
}

---@enum EB1PostProcessComponentTargetType
local EB1PostProcessComponentTargetType = {
    Player = 0,
    ViewTarget = 1,
    Camera = 2,
    EB1PostProcessComponentTargetType_MAX = 3,
}

---@enum EB1PostProcessTargetType
local EB1PostProcessTargetType = {
    Player = 0,
    ViewTarget = 1,
    Camera = 2,
    EB1PostProcessTargetType_MAX = 3,
}

---@enum EB1RotationAxis
local EB1RotationAxis = {
    Pitch = 0,
    Yaw = 1,
    Roll = 2,
    EB1RotationAxis_MAX = 3,
}

---@enum EB1RotationInputType
local EB1RotationInputType = {
    None = 0,
    Gizmo = 1,
    ZCKey = 2,
    RightMouse = 3,
    EB1RotationInputType_MAX = 4,
}

---@enum EB1SaveLoadListType
local EB1SaveLoadListType = {
    Default = 0,
    AutoSave = 1,
    EB1SaveLoadListType_MAX = 2,
}

---@enum EB1SaveType
local EB1SaveType = {
    Save = 0,
    AutoSave = 1,
    EB1SaveType_MAX = 2,
}

---@enum EB1ScheduleBarType
local EB1ScheduleBarType = {
    Invalid = 0,
    Normal = 1,
    Override = 2,
    Job = 3,
    Cancel = 4,
    EB1ScheduleBarType_MAX = 5,
}

---@enum EB1ScheduleEditDragType
local EB1ScheduleEditDragType = {
    None = 0,
    ScheduleBar = 1,
    LeftHandle = 2,
    RightHandle = 3,
    EB1ScheduleEditDragType_MAX = 4,
}

---@enum EB1ScheduleSelectEntryState
local EB1ScheduleSelectEntryState = {
    Normal = 0,
    Empty = 1,
    TopShowTitle = 2,
    EB1ScheduleSelectEntryState_MAX = 3,
}

---@enum EB1ScreenEffectType
local EB1ScreenEffectType = {
    Invalid = 0,
    CatFoot = 1,
    EB1ScreenEffectType_MAX = 2,
}

---@enum EB1SmartphoneHeaderWidgetColor
local EB1SmartphoneHeaderWidgetColor = {
    Black = 0,
    White = 1,
    EB1SmartphoneHeaderWidgetColor_MAX = 2,
}

---@enum EB1StartAnimType
local EB1StartAnimType = {
    None = 0,
    WalkStart = 1,
    JogStart = 2,
    WalkToJog = 3,
    JogToWalk = 4,
    EB1StartAnimType_MAX = 5,
}

---@enum EB1StructureType
local EB1StructureType = {
    None = 0,
    Wall = 1,
    Floor = 2,
    Ceil = 3,
    EB1StructureType_MAX = 4,
}

---@enum EB1StudioWidgetType
local EB1StudioWidgetType = {
    Invalid = 0,
    StudioPhoto = 1,
    StudioCutScene = 2,
    StudioDance = 3,
    EB1StudioWidgetType_MAX = 4,
}

---@enum EB1SubActionAnimState
local EB1SubActionAnimState = {
    None = 0,
    Loading = 1,
    WaitingForMotionWarping = 2,
    Playing = 3,
    Ended = 4,
    EB1SubActionAnimState_MAX = 5,
}

---@enum EB1SubMaterialType
local EB1SubMaterialType = {
    Base = 0,
    Opaque = 1,
    Masked = 2,
    Translucent = 3,
    Test = 4,
    EB1SubMaterialType_MAX = 5,
}

---@enum EB1TooltipWidgetContentType
local EB1TooltipWidgetContentType = {
    ContentOnly = 0,
    ContentAndBorder = 1,
    EB1TooltipWidgetContentType_MAX = 2,
}

---@enum EB1TopMenuCategory
local EB1TopMenuCategory = {
    Wall = 0,
    Camera = 1,
    Build = 2,
    Filter = 3,
    UpStairs = 4,
    DownStairs = 5,
    Bag = 6,
    More = 7,
    EB1TopMenuCategory_MAX = 8,
}

---@enum EB1TrafficLightStateFlag
local EB1TrafficLightStateFlag = {
    None = 0,
    VehicleGo = 1,
    VehiclePrepareToStop = 2,
    PedestrianGo_FrontSide = 4,
    PedestrianGo_LeftSide = 8,
    PedestrianGo_RightSide = 16,
    PedestrianGo = 28,
    EB1TrafficLightStateFlag_MAX = 29,
}

---@enum EB1TraitLineState
local EB1TraitLineState = {
    Normal = 0,
    Opposite = 1,
    Dimmed = 2,
    HighLight = 3,
    HighLightDimmed = 4,
    EB1TraitLineState_MAX = 5,
}

---@enum EB1TraitPointState
local EB1TraitPointState = {
    Normal = 0,
    Dimmed = 1,
    HighLight = 2,
    HighLightDimmed = 3,
    EB1TraitPointState_MAX = 4,
}

---@enum EB1UICustomizationPositionType
local EB1UICustomizationPositionType = {
    ByRatio = 0,
    ByGridIndex = 1,
    EB1UICustomizationPositionType_MAX = 2,
}

---@enum EB1UICustomizationWidgetType
local EB1UICustomizationWidgetType = {
    MainWidget = 0,
    SubWidget = 1,
    EB1UICustomizationWidgetType_MAX = 2,
}

---@enum EB1VehicleDialogRequestReason
local EB1VehicleDialogRequestReason = {
    Invalid = 0,
    EnterVehicle = 1,
    AutoDriving = 2,
    EB1VehicleDialogRequestReason_MAX = 3,
}

---@enum EB1VehicleDialogWidgetType
local EB1VehicleDialogWidgetType = {
    Invalid = 0,
    NavigationDialog = 1,
    AutoDrivingGuide = 2,
    EB1VehicleDialogWidgetType_MAX = 3,
}

---@enum EB1VehicleManagementCategory
local EB1VehicleManagementCategory = {
    Invalid = 0,
    Buy = 1,
    Sell = 2,
    Management = 3,
    EB1VehicleManagementCategory_MAX = 4,
}

---@enum EBlueAutoTestState
local EBlueAutoTestState = {
    InitialLoad = 0,
    Intro = 1,
    Soak = 2,
    TestSequence = 3,
    Finished = 4,
    Shutdown = 5,
    MAX = 6,
}

---@enum EBlueClientInitType
local EBlueClientInitType = {
    None = 0,
    LoginScene = 1,
    EBlueClientInitType_MAX = 2,
}

---@enum ECameraAutoFollowMode
local ECameraAutoFollowMode = {
    None = 0,
    LazyFollow = 1,
    FullFollow = 2,
    ECameraAutoFollowMode_MAX = 3,
}

---@enum ECameraFocusFlag
local ECameraFocusFlag = {
    None = 0,
    SelectFocus = 1,
    InputMove = 2,
    AutoMove = 4,
    OnceFocus = 8,
    ECameraFocusFlag_MAX = 9,
}

---@enum EDebugCameraStyle
local EDebugCameraStyle = {
    None = 0,
    Fixed = 1,
    ThirdPerson = 2,
    FreeCam = 3,
    FreeCam_Default = 4,
    FirstPerson = 5,
    EDebugCameraStyle_MAX = 6,
}

---@enum EHoverDroneDebug
local EHoverDroneDebug = {
    Off = 0,
    Position = 1,
    Velocity = 4,
    RotationalVelocity = 8,
    Altitude = 16,
    ForceFacing = 32,
    FOV = 64,
    All = 125,
    EHoverDroneDebug_MAX = 126,
}

---@enum EScrollDiection
local EScrollDiection = {
    None = 0,
    Up = 1,
    Down = 2,
    EScrollDiection_MAX = 3,
}

