---@meta

---@class FB1Packet
local FB1Packet = {}


---@class FB1PacketData
local FB1PacketData = {}


---@class FB1Packet_C_AddGeneratedMotionSlotData : FB1PacketData
---@field FileKey FString
---@field PlayLength float
local FB1Packet_C_AddGeneratedMotionSlotData = {}



---@class FB1Packet_C_AddTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitName FName
local FB1Packet_C_AddTrait = {}



---@class FB1Packet_C_AddTraitList : FB1PacketData
---@field EntityID FB1EntityId
---@field InTraitNameList TArray<FName>
---@field bAddPreference boolean
local FB1Packet_C_AddTraitList = {}



---@class FB1Packet_C_AdjustLocation : FB1PacketData
---@field EntityID FB1EntityId
---@field OldLocation FVector
---@field NewLocation FVector
---@field AdjustedLocation FVector
---@field bSafeMove boolean
---@field bFindFloor boolean
---@field bHit boolean
local FB1Packet_C_AdjustLocation = {}



---@class FB1Packet_C_CancelInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field CancelReason EB1InteractionCancelReason
---@field InteractionQueueId int64
local FB1Packet_C_CancelInteraction = {}



---@class FB1Packet_C_CancelSelectZoi : FB1PacketData
---@field SelfEntityId FB1EntityId
local FB1Packet_C_CancelSelectZoi = {}



---@class FB1Packet_C_ChangeAutonomyEnable : FB1PacketData
---@field EntityID FB1EntityId
---@field bAutonomyEnable boolean
local FB1Packet_C_ChangeAutonomyEnable = {}



---@class FB1Packet_C_ChangeHouseholdName : FB1PacketData
---@field HouseholdEntityId FB1EntityId
---@field ChangeCustomName FString
local FB1Packet_C_ChangeHouseholdName = {}



---@class FB1Packet_C_ChangePossess : FB1PacketData
---@field EntityID FB1EntityId
---@field bCloseMapMode boolean
local FB1Packet_C_ChangePossess = {}



---@class FB1Packet_C_ChangeScheduleState : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
---@field ScheduleControlState EB1ScheduleControlState
local FB1Packet_C_ChangeScheduleState = {}



---@class FB1Packet_C_Cheat : FB1PacketData
---@field CheatCommand FString
local FB1Packet_C_Cheat = {}



---@class FB1Packet_C_CheckJobInducementAlert : FB1PacketData
---@field CharacterId FB1EntityId
local FB1Packet_C_CheckJobInducementAlert = {}



---@class FB1Packet_C_CloseChoiceCardPopup : FB1PacketData
local FB1Packet_C_CloseChoiceCardPopup = {}


---@class FB1Packet_C_CloseNumericPopup : FB1PacketData
---@field TargetEntityId FB1EntityId
---@field ObjectEntityId FB1EntityId
---@field Number int64
local FB1Packet_C_CloseNumericPopup = {}



---@class FB1Packet_C_ClosePopupAction : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_ClosePopupAction = {}



---@class FB1Packet_C_CompleteSelectZoi : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetIdList TArray<FB1EntityId>
local FB1Packet_C_CompleteSelectZoi = {}



---@class FB1Packet_C_DeSelectHope : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field DeSelectHopeId FName
local FB1Packet_C_DeSelectHope = {}



---@class FB1Packet_C_DeleteGeneratedMotionSlotData : FB1PacketData
---@field FileKey FString
local FB1Packet_C_DeleteGeneratedMotionSlotData = {}



---@class FB1Packet_C_DestroyGameObjectOnBuildMode : FB1PacketData
---@field ObjectEntityIds TArray<FB1EntityId>
local FB1Packet_C_DestroyGameObjectOnBuildMode = {}



---@class FB1Packet_C_EnableAllCharacterAutonomy : FB1PacketData
---@field bAutonomyEnable boolean
local FB1Packet_C_EnableAllCharacterAutonomy = {}



---@class FB1Packet_C_EndActionCraftBuildMode : FB1PacketData
---@field InteractionEntityId FB1EntityId
local FB1Packet_C_EndActionCraftBuildMode = {}



---@class FB1Packet_C_EndActionGenerateMotion : FB1PacketData
---@field RequestEntityId FB1EntityId
local FB1Packet_C_EndActionGenerateMotion = {}



---@class FB1Packet_C_EndBuildMode : FB1PacketData
---@field LastEntityId int64
---@field SiteEntireSaveData FB2SiteEntireSaveData
local FB1Packet_C_EndBuildMode = {}



---@class FB1Packet_C_EndCharacterCustomization : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_EndCharacterCustomization = {}



---@class FB1Packet_C_EndKarmaInvolving : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_EndKarmaInvolving = {}



---@class FB1Packet_C_EndSubAction : FB1PacketData
---@field EntityID FB1EntityId
---@field SubActionType EB1SubActionType
---@field bIsCancel boolean
local FB1Packet_C_EndSubAction = {}



---@class FB1Packet_C_FailPlayGeneratedMotion : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_FailPlayGeneratedMotion = {}



---@class FB1Packet_C_FinishAsyncLoad : FB1PacketData
---@field AsyncLoadId FB1AsyncLoadId
local FB1Packet_C_FinishAsyncLoad = {}



---@class FB1Packet_C_FinishDivorce : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
local FB1Packet_C_FinishDivorce = {}



---@class FB1Packet_C_FinishDivorceHousehold : FB1PacketData
---@field RequestEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field EvictHouseholdInfo FB1HouseholdInfo
local FB1Packet_C_FinishDivorceHousehold = {}



---@class FB1Packet_C_FinishMarriageFamilyMove : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field IsSuccess boolean
local FB1Packet_C_FinishMarriageFamilyMove = {}



---@class FB1Packet_C_FinishVideoAction : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_FinishVideoAction = {}



---@class FB1Packet_C_FinishtSocialEventPopup : FB1PacketData
---@field IsEnterPhotoMode boolean
local FB1Packet_C_FinishtSocialEventPopup = {}



---@class FB1Packet_C_ForcedPassengersExitFinished : FB1PacketData
---@field VehicleEntityId FB1EntityId
---@field PassengerList TArray<FB1EntityId>
local FB1Packet_C_ForcedPassengersExitFinished = {}



---@class FB1Packet_C_GenerateNewGame : FB1PacketData
local FB1Packet_C_GenerateNewGame = {}


---@class FB1Packet_C_Init : FB1PacketData
---@field City FString
local FB1Packet_C_Init = {}



---@class FB1Packet_C_IsReachableAutoDrive : FB1PacketData
---@field Soruce FVector
---@field destination FVector
---@field CityGraphCategory EB1CityGraphCategory
local FB1Packet_C_IsReachableAutoDrive = {}



---@class FB1Packet_C_MainPerspectiveChangeInit : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_MainPerspectiveChangeInit = {}



---@class FB1Packet_C_Move : FB1PacketData
---@field EntityID FB1EntityId
---@field Pos FVector
---@field Rot FRotator
---@field Velocity FVector
---@field bInputMove boolean
---@field duration float
local FB1Packet_C_Move = {}



---@class FB1Packet_C_MoveAOICenter : FB1PacketData
---@field CenterLocation FVector
---@field CameraLocation FVector
local FB1Packet_C_MoveAOICenter = {}



---@class FB1Packet_C_MoveInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueueId int64
---@field NewIndex int32
local FB1Packet_C_MoveInteraction = {}



---@class FB1Packet_C_NotifyTimelineEditMode : FB1PacketData
---@field bSet boolean
local FB1Packet_C_NotifyTimelineEditMode = {}



---@class FB1Packet_C_OnBuyCatShopItem : FB1PacketData
---@field EntityID FB1EntityId
---@field CatShopId FName
local FB1Packet_C_OnBuyCatShopItem = {}



---@class FB1Packet_C_OnChangeIsInViewportCharacter : FB1PacketData
---@field IsInViewportCharacterMap TMap<FB1EntityId, boolean>
local FB1Packet_C_OnChangeIsInViewportCharacter = {}



---@class FB1Packet_C_OnChangeNodeIndex : FB1PacketData
---@field EntityID FB1EntityId
---@field NewNodeIndex int32
---@field PathId uint32
---@field AdjustedLocation FVector
local FB1Packet_C_OnChangeNodeIndex = {}



---@class FB1Packet_C_OnClickedStatDesireButton : FB1PacketData
---@field StatId FName
local FB1Packet_C_OnClickedStatDesireButton = {}



---@class FB1Packet_C_OnCloseLoadingUI : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnCloseLoadingUI = {}



---@class FB1Packet_C_OnFinishLevelSequence : FB1PacketData
---@field ActionOwnerEntityId FB1EntityId
local FB1Packet_C_OnFinishLevelSequence = {}



---@class FB1Packet_C_OnMessageRead : FB1PacketData
---@field MessageOwner FB1EntityId
---@field Partner FB1EntityId
---@field SenderSystem FName
local FB1Packet_C_OnMessageRead = {}



---@class FB1Packet_C_OnOpenLoadingUI : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnOpenLoadingUI = {}



---@class FB1Packet_C_OnSpawnedCharacter : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnSpawnedCharacter = {}



---@class FB1Packet_C_OnSpawnedCharacterMesh : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnSpawnedCharacterMesh = {}



---@class FB1Packet_C_OnSpawnedGameObject : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnSpawnedGameObject = {}



---@class FB1Packet_C_OnTeleportFinished : FB1PacketData
---@field EntityID FB1EntityId
---@field Pos FVector
---@field Rot FRotator
local FB1Packet_C_OnTeleportFinished = {}



---@class FB1Packet_C_OnUpdateGameObjectInfo : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_OnUpdateGameObjectInfo = {}



---@class FB1Packet_C_OverlapDoor : FB1PacketData
---@field EntityID FB1EntityId
---@field bIsOverlap boolean
local FB1Packet_C_OverlapDoor = {}



---@class FB1Packet_C_PathMovePause : FB1PacketData
---@field EntityID FB1EntityId
---@field Pos FVector
---@field bPause boolean
---@field Reason FName
local FB1Packet_C_PathMovePause = {}



---@class FB1Packet_C_PostChildBirth : FB1PacketData
---@field EntityID FB1EntityId
---@field FirstName FString
---@field LastName FString
local FB1Packet_C_PostChildBirth = {}



---@class FB1Packet_C_ProcessMotionWarping : FB1PacketData
---@field EntityID FB1EntityId
---@field NewLocation FVector
---@field NewRotation FRotator
---@field blendAlphaMotionWarping float
---@field AccTime float
---@field bSafeMove boolean
---@field bFindFloor boolean
---@field bEnableMotionWarping boolean
---@field bHit boolean
local FB1Packet_C_ProcessMotionWarping = {}



---@class FB1Packet_C_ProcessMovement : FB1PacketData
---@field EntityID FB1EntityId
---@field NewLocation FVector
---@field NewRotation FRotator
---@field bSafeMove boolean
---@field bFindFloor boolean
---@field bHit boolean
local FB1Packet_C_ProcessMovement = {}



---@class FB1Packet_C_PutDownInventoryObject : FB1PacketData
---@field InventoryEntityId FB1EntityId
---@field GameObjectEntityId FB1EntityId
local FB1Packet_C_PutDownInventoryObject = {}



---@class FB1Packet_C_PutInSiteInventory : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field GameObjectEntityIds TArray<FB1EntityId>
local FB1Packet_C_PutInSiteInventory = {}



---@class FB1Packet_C_PutOutSiteInventory : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field GameObjectEntityIds TArray<FB1EntityId>
local FB1Packet_C_PutOutSiteInventory = {}



---@class FB1Packet_C_QueryNavigationSkippable : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_QueryNavigationSkippable = {}



---@class FB1Packet_C_ReArrangeHopes : FB1PacketData
---@field SelectedPlayerId FB1EntityId
---@field DeSelectSlot int32
---@field bUpdateListView boolean
local FB1Packet_C_ReArrangeHopes = {}



---@class FB1Packet_C_RefreshAppearance : FB1PacketData
---@field EntityID FB1EntityId
---@field AppearanceSetting FB1AppearanceSetting
local FB1Packet_C_RefreshAppearance = {}



---@class FB1Packet_C_RefreshFamilyTimelineData : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RefreshFamilyTimelineData = {}



---@class FB1Packet_C_RegisterVehicle : FB1PacketData
---@field EntityID FB1EntityId
---@field VehicleDtId FName
---@field ColorId FName
local FB1Packet_C_RegisterVehicle = {}



---@class FB1Packet_C_RemoveAllHouseholdMonitoringNotifications : FB1PacketData
---@field HouseholdEntityId FB1EntityId
local FB1Packet_C_RemoveAllHouseholdMonitoringNotifications = {}



---@class FB1Packet_C_RemovePublishableFromCraftingUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field CraftObjectEntityId FB1EntityId
---@field CraftingId FName
local FB1Packet_C_RemovePublishableFromCraftingUI = {}



---@class FB1Packet_C_RemoveTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitName FName
local FB1Packet_C_RemoveTrait = {}



---@class FB1Packet_C_ReqAddPermissionThroughPreset : FB1PacketData
---@field EntityID FB1EntityId
---@field PermissionId FName
---@field bPutLog boolean
local FB1Packet_C_ReqAddPermissionThroughPreset = {}



---@class FB1Packet_C_ReqClearPermission : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_ReqClearPermission = {}



---@class FB1Packet_C_ReqRemoveCondition : FB1PacketData
---@field EntityID FB1EntityId
---@field PermissionId FName
---@field ConditionIndex int32
local FB1Packet_C_ReqRemoveCondition = {}



---@class FB1Packet_C_ReqRemovePermission : FB1PacketData
---@field EntityID FB1EntityId
---@field PermissionId FName
local FB1Packet_C_ReqRemovePermission = {}



---@class FB1Packet_C_ReqUpdateAccessiblePermissionGroup : FB1PacketData
---@field EntityID FB1EntityId
---@field InPermissionGroup EB1DoorPermissionGroup
local FB1Packet_C_ReqUpdateAccessiblePermissionGroup = {}



---@class FB1Packet_C_ReqUpdateDoorOwnerEntity : FB1PacketData
---@field EntityID FB1EntityId
---@field OwnerEntityId FB1EntityId
local FB1Packet_C_ReqUpdateDoorOwnerEntity = {}



---@class FB1Packet_C_RequestAddProfileUnlockHistory : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field UnlockHistories TSet<EB1RelationshipProfileType>
local FB1Packet_C_RequestAddProfileUnlockHistory = {}



---@class FB1Packet_C_RequestAddSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field Index int32
---@field SiteId FName
local FB1Packet_C_RequestAddSchedule = {}



---@class FB1Packet_C_RequestAddSellItem : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field Price int64
---@field UserInputItemName FText
local FB1Packet_C_RequestAddSellItem = {}



---@class FB1Packet_C_RequestAddTime : FB1PacketData
---@field InDay int32
---@field InHour int32
---@field InMinute int32
local FB1Packet_C_RequestAddTime = {}



---@class FB1Packet_C_RequestAnim : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestAnim = {}



---@class FB1Packet_C_RequestApplyJob : FB1PacketData
---@field EntityID FB1EntityId
---@field JobSearchData FB1JobSearchJobData
---@field bNewEmployment boolean
local FB1Packet_C_RequestApplyJob = {}



---@class FB1Packet_C_RequestAvailableInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field ImpactLocation FVector
---@field InteractionBagIds TArray<FName>
local FB1Packet_C_RequestAvailableInteractionBagList = {}



---@class FB1Packet_C_RequestAvailableRabbitHoleInteractionIdList : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestAvailableRabbitHoleInteractionIdList = {}



---@class FB1Packet_C_RequestAvailableRemoteSelections : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionBagIds TArray<FName>
local FB1Packet_C_RequestAvailableRemoteSelections = {}



---@class FB1Packet_C_RequestAvailableTalkInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
local FB1Packet_C_RequestAvailableTalkInteractionBagList = {}



---@class FB1Packet_C_RequestAvailableVehicleInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionBagIds TArray<FName>
local FB1Packet_C_RequestAvailableVehicleInteractionBagList = {}



---@class FB1Packet_C_RequestBuyShoppingItem : FB1PacketData
---@field BuyerEntityId FB1EntityId
---@field CategoryId FName
---@field ItemId FName
local FB1Packet_C_RequestBuyShoppingItem = {}



---@class FB1Packet_C_RequestCanAddInteraction : FB1PacketData
---@field RequestEntityId FB1EntityId
---@field PickedEntityId FB1EntityId
---@field bIsClick boolean
local FB1Packet_C_RequestCanAddInteraction = {}



---@class FB1Packet_C_RequestCanSaveGameObject : FB1PacketData
---@field OwnerHouseholdEntityId FB1EntityId
local FB1Packet_C_RequestCanSaveGameObject = {}



---@class FB1Packet_C_RequestCancelCoop : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field CoopResult EB1CoopResult
local FB1Packet_C_RequestCancelCoop = {}



---@class FB1Packet_C_RequestChangeDailyAllScheduleState : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeekList TArray<EB1DayOfWeek>
---@field ScheduleControlState EB1ScheduleControlState
local FB1Packet_C_RequestChangeDailyAllScheduleState = {}



---@class FB1Packet_C_RequestChangeGenderIdentity : FB1PacketData
---@field EntityID FB1EntityId
---@field GenderIdentitySetting FB1GenderIdentitySetting
local FB1Packet_C_RequestChangeGenderIdentity = {}



---@class FB1Packet_C_RequestChangeHopeLife : FB1PacketData
---@field EntityID FB1EntityId
---@field HopeLifeId FName
local FB1Packet_C_RequestChangeHopeLife = {}



---@class FB1Packet_C_RequestChangeState : FB1PacketData
---@field EntityID FB1EntityId
---@field StateGroupId FName
---@field StateId FName
local FB1Packet_C_RequestChangeState = {}



---@class FB1Packet_C_RequestCharacterDataCache : FB1PacketData
---@field RequestID int64
---@field RequestEntityIds TArray<FB1EntityId>
---@field GroupType EB1CharacterDataCacheGroup
local FB1Packet_C_RequestCharacterDataCache = {}



---@class FB1Packet_C_RequestCheckDoorPermission : FB1PacketData
---@field DoorEntityIds TArray<FB1EntityId>
---@field TargetEntityId FB1EntityId
local FB1Packet_C_RequestCheckDoorPermission = {}



---@class FB1Packet_C_RequestCheckObjectSkillConditionList : FB1PacketData
---@field SelectedSiteId FName
---@field ObjectConditionList TMap<FName, FName>
local FB1Packet_C_RequestCheckObjectSkillConditionList = {}



---@class FB1Packet_C_RequestCheckWalkableGround : FB1PacketData
---@field EntityID FB1EntityId
---@field ImpactPoint FVector
local FB1Packet_C_RequestCheckWalkableGround = {}



---@class FB1Packet_C_RequestClearAllCustomSchedules : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestClearAllCustomSchedules = {}



---@class FB1Packet_C_RequestClearCustomSchedules : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
local FB1Packet_C_RequestClearCustomSchedules = {}



---@class FB1Packet_C_RequestContinuePublishableCrafting : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field CraftObjectEntityId FB1EntityId
---@field WorkbenchEntityId FB1EntityId
local FB1Packet_C_RequestContinuePublishableCrafting = {}



---@class FB1Packet_C_RequestCoop : FB1PacketData
---@field CoopType EB1CoopType
---@field CoopId FName
---@field SelfEntityId FB1EntityId
---@field MainTargetEntityId FB1EntityId
---@field TargetIdList TArray<FB1EntityId>
---@field PickedImpactPoint FVector
local FB1Packet_C_RequestCoop = {}



---@class FB1Packet_C_RequestCreateSocialEvent : FB1PacketData
---@field SettingParam FB1SiteEventSettingParam
local FB1Packet_C_RequestCreateSocialEvent = {}



---@class FB1Packet_C_RequestDoorToggleCheckPermission : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field bShowNoPermissionMsg boolean
---@field bOpen boolean
---@field bFromInsidePermissionCheck boolean
local FB1Packet_C_RequestDoorToggleCheckPermission = {}



---@class FB1Packet_C_RequestEnterVehicle : FB1PacketData
---@field RequesterEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
---@field PassengerIdList TArray<FB1EntityId>
local FB1Packet_C_RequestEnterVehicle = {}



---@class FB1Packet_C_RequestEvictFamilyFromSite : FB1PacketData
---@field SiteId FName
---@field OwnerHouseholdEntityId FB1EntityId
local FB1Packet_C_RequestEvictFamilyFromSite = {}



---@class FB1Packet_C_RequestExchangeCostInSite : FB1PacketData
---@field SiteEntityId FB1EntityId
local FB1Packet_C_RequestExchangeCostInSite = {}



---@class FB1Packet_C_RequestExecuteScript : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field Reason EB1ScriptReason
---@field ScriptId FName
local FB1Packet_C_RequestExecuteScript = {}



---@class FB1Packet_C_RequestGamePause : FB1PacketData
---@field PauseReason EB1PauseReason
---@field bPause boolean
local FB1Packet_C_RequestGamePause = {}



---@class FB1Packet_C_RequestInitialState : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestInitialState = {}



---@class FB1Packet_C_RequestInteraction : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionBagId FName
---@field PlayReason EB1InteractionPlayReason
---@field ImpactPoint FVector
local FB1Packet_C_RequestInteraction = {}



---@class FB1Packet_C_RequestInteractionFromInventory : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field ObjectEntityId FB1EntityId
---@field InteractionBagId FName
local FB1Packet_C_RequestInteractionFromInventory = {}



---@class FB1Packet_C_RequestJoinCompany : FB1PacketData
---@field EntityID FB1EntityId
---@field CompanyEntityId FB1EntityId
---@field DepartmentKey FB1DepartmentKey
---@field bForce boolean
---@field bNewEmployment boolean
local FB1Packet_C_RequestJoinCompany = {}



---@class FB1Packet_C_RequestKarmaInvolving : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestKarmaInvolving = {}



---@class FB1Packet_C_RequestLeaveCompany : FB1PacketData
---@field EntityID FB1EntityId
---@field CompanyEntityId FB1EntityId
---@field LeaveCompanyReason EB1LeaveCompanyReason
local FB1Packet_C_RequestLeaveCompany = {}



---@class FB1Packet_C_RequestModifyCustomScheduleSite : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
---@field SiteId FName
local FB1Packet_C_RequestModifyCustomScheduleSite = {}



---@class FB1Packet_C_RequestModifyCustomScheduleTime : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
---@field StartTime int32
---@field EndTime int32
local FB1Packet_C_RequestModifyCustomScheduleTime = {}



---@class FB1Packet_C_RequestMoveInFamilyToSite : FB1PacketData
---@field SiteId FName
---@field OwnerHouseholdEntityId FB1EntityId
---@field bPossess boolean
---@field bPlayInitalStartVideo boolean
---@field FamilyMoveFamilyOption EB1FamilyMoveFamilyOption
---@field FamilyMoveSiteOption EB1FamilyMoveSiteOption
local FB1Packet_C_RequestMoveInFamilyToSite = {}



---@class FB1Packet_C_RequestMoveLevel : FB1PacketData
---@field LevelName FName
local FB1Packet_C_RequestMoveLevel = {}



---@class FB1Packet_C_RequestMoveSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field ScheduleMoveType EB1ScheduleMoveType
local FB1Packet_C_RequestMoveSchedule = {}



---@class FB1Packet_C_RequestMoveToDest_Vehicle : FB1PacketData
---@field DriverEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
---@field SiteEntityId FB1EntityId
---@field ImpactPoint FVector
local FB1Packet_C_RequestMoveToDest_Vehicle = {}



---@class FB1Packet_C_RequestNearestCityGraphPoint : FB1PacketData
---@field QueryParam FB1CityGraphPointQuery
---@field bMustUsePortal boolean
local FB1Packet_C_RequestNearestCityGraphPoint = {}



---@class FB1Packet_C_RequestOpenCreateSocialEventPopup : FB1PacketData
---@field HostEntityId FB1EntityId
---@field EventStartTime int64
local FB1Packet_C_RequestOpenCreateSocialEventPopup = {}



---@class FB1Packet_C_RequestPriceDown : FB1PacketData
---@field CharacterEntityId FB1EntityId
---@field ItemEntityId FB1EntityId
local FB1Packet_C_RequestPriceDown = {}



---@class FB1Packet_C_RequestRabbitHoleInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field RabbitHoleInteractionId FName
local FB1Packet_C_RequestRabbitHoleInteraction = {}



---@class FB1Packet_C_RequestRecruitInfos : FB1PacketData
---@field CharacterId FB1EntityId
---@field InWithEmptyHeadcount boolean
---@field JobType EB1JobType
local FB1Packet_C_RequestRecruitInfos = {}



---@class FB1Packet_C_RequestRefreshPurchasedShoppingItems : FB1PacketData
---@field CharacterEntityId FB1EntityId
local FB1Packet_C_RequestRefreshPurchasedShoppingItems = {}



---@class FB1Packet_C_RequestRefreshSellItems : FB1PacketData
---@field CharacterEntityId FB1EntityId
local FB1Packet_C_RequestRefreshSellItems = {}



---@class FB1Packet_C_RequestRefreshShoppingItems : FB1PacketData
---@field CharacterEntityId FB1EntityId
local FB1Packet_C_RequestRefreshShoppingItems = {}



---@class FB1Packet_C_RequestRegisterCustomizedCharacters : FB1PacketData
---@field HouseholdEntityId FB1EntityId
---@field RequestCustomizedCharacterInfoList TArray<FB1CustomizedCharacterInfo>
local FB1Packet_C_RequestRegisterCustomizedCharacters = {}



---@class FB1Packet_C_RequestRegisterCustomizedHousehold : FB1PacketData
---@field RequestCustomizedHouseholdInfo FB1CustomizedHouseholdInfo
local FB1Packet_C_RequestRegisterCustomizedHousehold = {}



---@class FB1Packet_C_RequestRemoveHouseholds : FB1PacketData
---@field HouseholdEntityIds TArray<FB1EntityId>
local FB1Packet_C_RequestRemoveHouseholds = {}



---@class FB1Packet_C_RequestRemoveSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
local FB1Packet_C_RequestRemoveSchedule = {}



---@class FB1Packet_C_RequestReserveChangeJobDepartment : FB1PacketData
---@field CharacterId FB1EntityId
---@field JobSearchJobData FB1JobSearchJobData
local FB1Packet_C_RequestReserveChangeJobDepartment = {}



---@class FB1Packet_C_RequestSendMessageResponse : FB1PacketData
---@field SenderId FB1EntityId
---@field ReceiverId FB1EntityId
---@field ReceiverSystemId FName
---@field Type EB1MobileMessageResponseType
local FB1Packet_C_RequestSendMessageResponse = {}



---@class FB1Packet_C_RequestSetVehicleLightsFlag : FB1PacketData
---@field EntityID FB1EntityId
---@field VehicleLightsFlag EB1VehicleLight
---@field bOn boolean
local FB1Packet_C_RequestSetVehicleLightsFlag = {}



---@class FB1Packet_C_RequestSkipNavigation : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RequestSkipNavigation = {}



---@class FB1Packet_C_RequestSocialEventActionPlay : FB1PacketData
---@field ActionId FName
local FB1Packet_C_RequestSocialEventActionPlay = {}



---@class FB1Packet_C_RequestSocialEventActionResetAll : FB1PacketData
local FB1Packet_C_RequestSocialEventActionResetAll = {}


---@class FB1Packet_C_RequestSocialEventRoleSelectableRelationshipData : FB1PacketData
---@field HostEntityId FB1EntityId
---@field SocialEventTemplateId FName
---@field StartTime int64
---@field EndTime int64
---@field RoleId FName
local FB1Packet_C_RequestSocialEventRoleSelectableRelationshipData = {}



---@class FB1Packet_C_RequestSocialEventToggleScenarioFlag : FB1PacketData
local FB1Packet_C_RequestSocialEventToggleScenarioFlag = {}


---@class FB1Packet_C_RequestStartCrafting : FB1PacketData
---@field EntityID FB1EntityId
---@field WorkbenchEntityId FB1EntityId
---@field RecipeGroupId FName
---@field RecipeId FName
---@field CustomName FText
---@field CustomDescription FText
local FB1Packet_C_RequestStartCrafting = {}



---@class FB1Packet_C_RequestStopAutoDriving : FB1PacketData
---@field EntityID FB1EntityId
---@field AutoDrivingStopReason EB1AutoDrivingStopReason
local FB1Packet_C_RequestStopAutoDriving = {}



---@class FB1Packet_C_RequestSubmitQuest : FB1PacketData
---@field EntityID FB1EntityId
---@field QuestId FName
local FB1Packet_C_RequestSubmitQuest = {}



---@class FB1Packet_C_RequestUpdateDoorPermission : FB1PacketData
---@field DoorEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field OverlappingEntityIds TArray<FB1EntityId>
local FB1Packet_C_RequestUpdateDoorPermission = {}



---@class FB1Packet_C_RequestWalkToSite : FB1PacketData
---@field RequesterEntityId FB1EntityId
---@field TargetSiteEntityId FB1EntityId
local FB1Packet_C_RequestWalkToSite = {}



---@class FB1Packet_C_RescueCharacter : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_RescueCharacter = {}



---@class FB1Packet_C_RescueOnBuildMode : FB1PacketData
---@field CharacterIds TArray<FB1EntityId>
local FB1Packet_C_RescueOnBuildMode = {}



---@class FB1Packet_C_ResetNew : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field ResetNewHopeId FName
local FB1Packet_C_ResetNew = {}



---@class FB1Packet_C_ResetTrait : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_ResetTrait = {}



---@class FB1Packet_C_ResetUnreadHouseholdMonitoringNotificationCount : FB1PacketData
---@field HouseholdEntityId FB1EntityId
local FB1Packet_C_ResetUnreadHouseholdMonitoringNotificationCount = {}



---@class FB1Packet_C_ResponseResetSite : FB1PacketData
---@field SiteEntityId FB1EntityId
local FB1Packet_C_ResponseResetSite = {}



---@class FB1Packet_C_Restore : FB1PacketData
---@field FolderName FString
---@field Filename FString
---@field bIsNewGame boolean
local FB1Packet_C_Restore = {}



---@class FB1Packet_C_ResultCheckAvailableFirePos : FB1PacketData
---@field ResultList TArray<FB2SiteCheckAvailableFirePosParam>
local FB1Packet_C_ResultCheckAvailableFirePos = {}



---@class FB1Packet_C_SelectChoiceCardAnswer : FB1PacketData
---@field bIsPositive boolean
local FB1Packet_C_SelectChoiceCardAnswer = {}



---@class FB1Packet_C_SelectHope : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field SelectHopeId FName
local FB1Packet_C_SelectHope = {}



---@class FB1Packet_C_SellAtDepreciatedPrice : FB1PacketData
---@field SellingObjects TMap<FB1EntityId, int64>
---@field HouseholdEntityId FB1EntityId
---@field CurrencyId FName
---@field Value int64
---@field PlayWidgetEffectEntity FB1EntityId
---@field EffectLocation FVector
local FB1Packet_C_SellAtDepreciatedPrice = {}



---@class FB1Packet_C_SellPublishableFromCraftingUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field CraftObjectEntityId FB1EntityId
---@field CraftingId FName
local FB1Packet_C_SellPublishableFromCraftingUI = {}



---@class FB1Packet_C_SellPublishableFromInventoryUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field CraftObjectEntityId FB1EntityId
local FB1Packet_C_SellPublishableFromInventoryUI = {}



---@class FB1Packet_C_SellSiteInventoryObjects : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field bIsUndo boolean
---@field GameObjectEntityIds TArray<FB1EntityId>
local FB1Packet_C_SellSiteInventoryObjects = {}



---@class FB1Packet_C_SendAnimContext : FB1PacketData
---@field EntityID FB1EntityId
---@field CurrentLocation FVector
---@field CurrentRotation FRotator
---@field MoveDelta FVector
---@field RotationDelta FQuat
---@field MontageRootMotion FTransform
---@field bIsPlayingMontage boolean
---@field bRecentlyRendered boolean
local FB1Packet_C_SendAnimContext = {}



---@class FB1Packet_C_SendClearOverridenWeather : FB1PacketData
local FB1Packet_C_SendClearOverridenWeather = {}


---@class FB1Packet_C_SendCurrency : FB1PacketData
---@field HouseholdEntityId FB1EntityId
---@field CharacterEntityId FB1EntityId
---@field CurrencyId FName
---@field Value int64
---@field PlayWidgetEffectEntity FB1EntityId
---@field EffectLocation FVector
local FB1Packet_C_SendCurrency = {}



---@class FB1Packet_C_SendFamilyCurrency : FB1PacketData
---@field FromHouseholdEntityId FB1EntityId
---@field ToHouseholdEntityId FB1EntityId
---@field CurrencyId FName
---@field Value int64
local FB1Packet_C_SendFamilyCurrency = {}



---@class FB1Packet_C_SendGiftBox : FB1PacketData
---@field FromEntityId FB1EntityId
---@field ToEntityId FB1EntityId
---@field GiftDtId FName
local FB1Packet_C_SendGiftBox = {}



---@class FB1Packet_C_SendOverrideWeather : FB1PacketData
---@field Weather FString
---@field Step int32
local FB1Packet_C_SendOverrideWeather = {}



---@class FB1Packet_C_SendPreferenceData : FB1PacketData
---@field EntityID FB1EntityId
---@field PreferenceMap TMap<FName, boolean>
---@field PreferenceId FName
---@field PreferenceState EB1PreferenceState
local FB1Packet_C_SendPreferenceData = {}



---@class FB1Packet_C_SendWeatherPause : FB1PacketData
local FB1Packet_C_SendWeatherPause = {}


---@class FB1Packet_C_SendWeatherResume : FB1PacketData
local FB1Packet_C_SendWeatherResume = {}


---@class FB1Packet_C_SetAllPlayableCharactersAutonomy : FB1PacketData
---@field bEnable boolean
local FB1Packet_C_SetAllPlayableCharactersAutonomy = {}



---@class FB1Packet_C_SetDevelopersPermissionsMessageId : FB1PacketData
---@field EntityID FB1EntityId
---@field DevelopersPermissionsMessageId FName
local FB1Packet_C_SetDevelopersPermissionsMessageId = {}



---@class FB1Packet_C_SetDoorPermissionMode : FB1PacketData
---@field EntityID FB1EntityId
---@field PermissionMode EB1DoorPermissionMode
local FB1Packet_C_SetDoorPermissionMode = {}



---@class FB1Packet_C_SetSmartJoyTag : FB1PacketData
---@field TargetEntityId FB1EntityId
---@field SmartZoiTag FString
local FB1Packet_C_SetSmartJoyTag = {}



---@class FB1Packet_C_SetVehicleVelocity : FB1PacketData
---@field EntityID FB1EntityId
---@field Velocity FVector
local FB1Packet_C_SetVehicleVelocity = {}



---@class FB1Packet_C_ShowingInteractionBagRatio : FB1PacketData
---@field bIsShow boolean
local FB1Packet_C_ShowingInteractionBagRatio = {}



---@class FB1Packet_C_SimulationPlay : FB1PacketData
---@field bNewGame boolean
local FB1Packet_C_SimulationPlay = {}



---@class FB1Packet_C_SmartZoiActiveChanged : FB1PacketData
---@field bIsOn boolean
local FB1Packet_C_SmartZoiActiveChanged = {}



---@class FB1Packet_C_SmartZoiRangeInCityChanged : FB1PacketData
---@field InValue int32
local FB1Packet_C_SmartZoiRangeInCityChanged = {}



---@class FB1Packet_C_SmartZoiRangeInViewportChanged : FB1PacketData
---@field InValue int32
local FB1Packet_C_SmartZoiRangeInViewportChanged = {}



---@class FB1Packet_C_SmartZoiWaitingCountChanged : FB1PacketData
---@field InValue int32
local FB1Packet_C_SmartZoiWaitingCountChanged = {}



---@class FB1Packet_C_Snapshot : FB1PacketData
---@field FolderName FString
---@field Filename FString
---@field SlotName FString
---@field UseAsync boolean
---@field UseToast boolean
---@field bIsNewGame boolean
---@field bUsePopup boolean
local FB1Packet_C_Snapshot = {}



---@class FB1Packet_C_StartBuildMode : FB1PacketData
---@field EntityID FB1EntityId
---@field SiteId FName
local FB1Packet_C_StartBuildMode = {}



---@class FB1Packet_C_StartMarriage : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionBag FName
---@field SocialEventSettingParam FB1SiteEventSettingParam
local FB1Packet_C_StartMarriage = {}



---@class FB1Packet_C_StartVehicleHorn : FB1PacketData
---@field VehicleEntityId FB1EntityId
---@field OwnerEntityId FB1EntityId
local FB1Packet_C_StartVehicleHorn = {}



---@class FB1Packet_C_StopVehicleHorn : FB1PacketData
---@field VehicleEntityId FB1EntityId
---@field OwnerEntityId FB1EntityId
local FB1Packet_C_StopVehicleHorn = {}



---@class FB1Packet_C_SubActionStart : FB1PacketData
---@field EntityID FB1EntityId
---@field SubActionType EB1SubActionType
local FB1Packet_C_SubActionStart = {}



---@class FB1Packet_C_SuccessRegisterVehicle : FB1PacketData
---@field EntityID FB1EntityId
---@field VehicleColor float
local FB1Packet_C_SuccessRegisterVehicle = {}



---@class FB1Packet_C_SyncMovement : FB1PacketData
---@field EntityID FB1EntityId
---@field RestoreLocation FVector
---@field RestoreRotation FRotator
---@field FloorZ float
---@field RootMotionTransform FTransform
---@field bIsPlayingMontage boolean
local FB1Packet_C_SyncMovement = {}



---@class FB1Packet_C_SyncNavigationNode : FB1PacketData
---@field EntityID FB1EntityId
---@field NodeIndex int32
---@field Transform FTransform
---@field Reason FName
local FB1Packet_C_SyncNavigationNode = {}



---@class FB1Packet_C_TeleportHomeSite : FB1PacketData
---@field EntityID FB1EntityId
---@field SpawnIndex int32
local FB1Packet_C_TeleportHomeSite = {}



---@class FB1Packet_C_ThrowAwayInventoryObject : FB1PacketData
---@field InventoryEntityId FB1EntityId
---@field GameObjectEntityId FB1EntityId
local FB1Packet_C_ThrowAwayInventoryObject = {}



---@class FB1Packet_C_ToggleAIMode : FB1PacketData
---@field bIsOn boolean
local FB1Packet_C_ToggleAIMode = {}



---@class FB1Packet_C_TriggerInput : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_TriggerInput = {}



---@class FB1Packet_C_TriggerLeftMouseButtonReleased : FB1PacketData
---@field HitEntityId FB1EntityId
local FB1Packet_C_TriggerLeftMouseButtonReleased = {}



---@class FB1Packet_C_TryPlayAmbition : FB1PacketData
---@field EntityID FB1EntityId
---@field AmbitionId FName
local FB1Packet_C_TryPlayAmbition = {}



---@class FB1Packet_C_TryPossessAnotherFamilyMemberWithAge : FB1PacketData
---@field EntityID FB1EntityId
---@field GrowthStep EB1GrowthStep
local FB1Packet_C_TryPossessAnotherFamilyMemberWithAge = {}



---@class FB1Packet_C_TrySendAddPreference : FB1PacketData
---@field EntityID FB1EntityId
---@field PreferenceId FName
---@field bLike boolean
local FB1Packet_C_TrySendAddPreference = {}



---@class FB1Packet_C_UnregisterVehicle : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_UnregisterVehicle = {}



---@class FB1Packet_C_UpdateAllGeneratedMotionSlotData : FB1PacketData
---@field GeneratedMotionSlotDataList TArray<FB1GeneratedMotionSlotData>
local FB1Packet_C_UpdateAllGeneratedMotionSlotData = {}



---@class FB1Packet_C_UpdateBuildMode : FB1PacketData
---@field LastEntityId int64
---@field SiteEntireSaveData FB2SiteEntireSaveData
local FB1Packet_C_UpdateBuildMode = {}



---@class FB1Packet_C_UpdateBuiltData : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field SiteAreaBuiltSaveData FB1SiteAreaBuiltSaveData
local FB1Packet_C_UpdateBuiltData = {}



---@class FB1Packet_C_UpdateDecorationSpawn : FB1PacketData
---@field CategoryName FName
---@field Value float
---@field bIsUpdateCurrent boolean
local FB1Packet_C_UpdateDecorationSpawn = {}



---@class FB1Packet_C_UpdateHopeFix : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field UpdateHopeFixId FName
---@field bUpdateHopeFixVal boolean
local FB1Packet_C_UpdateHopeFix = {}



---@class FB1Packet_C_UpdateHouseholdInfoList : FB1PacketData
---@field HouseholdMoveInfoList TArray<FB1HouseholdMoveInfo>
---@field AssetTransferOwnerId FB1EntityId
local FB1Packet_C_UpdateHouseholdInfoList = {}



---@class FB1Packet_C_UpdateInvisibleObjectDuringInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field InvisibleObjectDuringInteraction boolean
---@field HideMeshComponentTag FName
local FB1Packet_C_UpdateInvisibleObjectDuringInteraction = {}



---@class FB1Packet_C_UpdateMarriedFamily : FB1PacketData
---@field SiteId FName
---@field NewFamilyInfo FB1HouseholdInfo
---@field PrevFamilyInfoList TArray<FB1HouseholdInfo>
---@field FamilyMoveFamilyOption EB1FamilyMoveFamilyOption
---@field FamilyMoveSiteOption EB1FamilyMoveSiteOption
local FB1Packet_C_UpdateMarriedFamily = {}



---@class FB1Packet_C_UpdatePathFindingData : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field SiteAreaPathFindingSaveData FB1SiteAreaPathFindingSaveData
local FB1Packet_C_UpdatePathFindingData = {}



---@class FB1Packet_C_UpdateRealTimeSecondsPerGameMinute : FB1PacketData
---@field InRealTimeSecondsPerGameMinute float
local FB1Packet_C_UpdateRealTimeSecondsPerGameMinute = {}



---@class FB1Packet_C_UpdateSelectedPlayerId : FB1PacketData
---@field SelectedPlayerId FB1EntityId
local FB1Packet_C_UpdateSelectedPlayerId = {}



---@class FB1Packet_C_UpdateSelection : FB1PacketData
---@field Selection TMap<FName, FB1MeshReplaceSelectionList>
local FB1Packet_C_UpdateSelection = {}



---@class FB1Packet_C_UpdateStablity : FB1PacketData
---@field ID FName
---@field Value float
local FB1Packet_C_UpdateStablity = {}



---@class FB1Packet_C_UpdateTakeOffShoes : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_C_UpdateTakeOffShoes = {}



---@class FB1Packet_C_UpdateTakeOffShoesToSite : FB1PacketData
---@field SiteEntityId FB1EntityId
---@field bTakeOffShoes boolean
local FB1Packet_C_UpdateTakeOffShoesToSite = {}



---@class FB1Packet_C_UpdateTimeScale : FB1PacketData
---@field timescale float
local FB1Packet_C_UpdateTimeScale = {}



---@class FB1Packet_C_UpdateTransform : FB1PacketData
---@field EntityID FB1EntityId
---@field Transform FTransform
local FB1Packet_C_UpdateTransform = {}



---@class FB1Packet_C_UpdateVisibility : FB1PacketData
---@field EntityID FB1EntityId
---@field RepresentationType EB1VehicleRepresentationType
local FB1Packet_C_UpdateVisibility = {}



---@class FB1Packet_C_VehicleOnBeginOverlap : FB1PacketData
---@field VehicleId FB1EntityId
---@field OtherId FB1EntityId
local FB1Packet_C_VehicleOnBeginOverlap = {}



---@class FB1Packet_C_VehicleOnEndOverlap : FB1PacketData
---@field VehicleId FB1EntityId
---@field OtherId FB1EntityId
local FB1Packet_C_VehicleOnEndOverlap = {}



---@class FB1Packet_C_WalkTo : FB1PacketData
---@field EntityID FB1EntityId
---@field Location FVector
---@field Rotation FRotator
---@field CurrentNodeIndex int32
---@field RequestCrossWalkNodeIndex int32
---@field PathId uint32
---@field bArrivedAtWaitingArea boolean
---@field IsFinishWalkAction boolean
local FB1Packet_C_WalkTo = {}



---@class FB1Packet_S_AckMoveLevel : FB1PacketData
---@field LevelName FName
---@field bResult boolean
local FB1Packet_S_AckMoveLevel = {}



---@class FB1Packet_S_ActionCraftBuildMode3DPrinter : FB1PacketData
---@field InteractionEntityId FB1EntityId
local FB1Packet_S_ActionCraftBuildMode3DPrinter = {}



---@class FB1Packet_S_ActionCraftBuildModeFurniture : FB1PacketData
---@field InteractionEntityId FB1EntityId
local FB1Packet_S_ActionCraftBuildModeFurniture = {}



---@class FB1Packet_S_AddBuff : FB1PacketData
---@field EntityID FB1EntityId
---@field Buff FB1Buff
---@field DesireBoostEmotionId FName
local FB1Packet_S_AddBuff = {}



---@class FB1Packet_S_AddHopeTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitId FName
---@field HopeLifeId FName
local FB1Packet_S_AddHopeTrait = {}



---@class FB1Packet_S_AddHouseholdMonitoringNotification : FB1PacketData
---@field NotificationData FB1HouseholdMonitoringNotificationData
local FB1Packet_S_AddHouseholdMonitoringNotification = {}



---@class FB1Packet_S_AddInteractionQueue : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueue TArray<FB1InteractionQueueUIData>
local FB1Packet_S_AddInteractionQueue = {}



---@class FB1Packet_S_AddMoveTogetherVM : FB1PacketData
---@field EntityID FB1EntityId
---@field MoveTogetherVM FB1MoveTogetherVM
local FB1Packet_S_AddMoveTogetherVM = {}



---@class FB1Packet_S_AddSkillExp : FB1PacketData
---@field EntityID FB1EntityId
---@field InExperience float
---@field ResultLevel int32
---@field PrevLevel int32
---@field InSkillName FName
---@field bIsSkillLevelUp boolean
---@field StartRatio float
---@field GoalRatio float
local FB1Packet_S_AddSkillExp = {}



---@class FB1Packet_S_AddSpeechBubble : FB1PacketData
---@field EntityID FB1EntityId
---@field SpeechBubbleId FName
---@field DelayTime float
local FB1Packet_S_AddSpeechBubble = {}



---@class FB1Packet_S_AddTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitIdList TArray<FName>
local FB1Packet_S_AddTrait = {}



---@class FB1Packet_S_AllRevertTemporaryAppearance : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_AllRevertTemporaryAppearance = {}



---@class FB1Packet_S_AmbitionChanged : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_AmbitionChanged = {}



---@class FB1Packet_S_AmbitionComplete : FB1PacketData
---@field EntityID FB1EntityId
---@field InAmbitionId FName
---@field IsAllCompleted boolean
local FB1Packet_S_AmbitionComplete = {}



---@class FB1Packet_S_AmbitionCompletionStatusChanged : FB1PacketData
---@field EntityID FB1EntityId
---@field InAmbitionItemId FName
---@field IsCompleted boolean
local FB1Packet_S_AmbitionCompletionStatusChanged = {}



---@class FB1Packet_S_AmbitionFinishMission : FB1PacketData
---@field EntityID FB1EntityId
---@field IsComplete boolean
---@field IsProgress boolean
local FB1Packet_S_AmbitionFinishMission = {}



---@class FB1Packet_S_AnimNotifyEvent_PlayAnim : FB1PacketData
---@field PlayingEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field PlayAnimInfo FB1PlayAnimInfo
local FB1Packet_S_AnimNotifyEvent_PlayAnim = {}



---@class FB1Packet_S_Ascend : FB1PacketData
---@field EntityID FB1EntityId
---@field GhostPopupId FName
local FB1Packet_S_Ascend = {}



---@class FB1Packet_S_AttachBabyBedEntity : FB1PacketData
---@field CradleEntityId FB1EntityId
---@field BabyEntityId FB1EntityId
---@field SiteEntityId FB1EntityId
---@field SlotName FName
local FB1Packet_S_AttachBabyBedEntity = {}



---@class FB1Packet_S_AttachCarriableObject : FB1PacketData
---@field CarriableObjectEntityId FB1EntityId
---@field OwnerEntityId FB1EntityId
---@field SocketName FName
local FB1Packet_S_AttachCarriableObject = {}



---@class FB1Packet_S_AttachCharacter : FB1PacketData
---@field ParentEntityId FB1EntityId
---@field ChildEntityId FB1EntityId
---@field SocketName FName
local FB1Packet_S_AttachCharacter = {}



---@class FB1Packet_S_AttachMesh : FB1PacketData
---@field EntityID FB1EntityId
---@field MeshId FName
local FB1Packet_S_AttachMesh = {}



---@class FB1Packet_S_CacheTemporaryMeshId : FB1PacketData
---@field EntityID FB1EntityId
---@field MeshId FName
local FB1Packet_S_CacheTemporaryMeshId = {}



---@class FB1Packet_S_CancelInteractionQueue : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueueId int64
---@field bIsImmediately boolean
local FB1Packet_S_CancelInteractionQueue = {}



---@class FB1Packet_S_CancelWalkTo : FB1PacketData
---@field EntityID FB1EntityId
---@field PathId uint32
local FB1Packet_S_CancelWalkTo = {}



---@class FB1Packet_S_ChangeActorHousehold : FB1PacketData
---@field EntityID FB1EntityId
---@field HouseholdEntityId FB1EntityId
local FB1Packet_S_ChangeActorHousehold = {}



---@class FB1Packet_S_ChangeAutonomyEnable : FB1PacketData
---@field EntityID FB1EntityId
---@field bAutonomyEnable boolean
local FB1Packet_S_ChangeAutonomyEnable = {}



---@class FB1Packet_S_ChangeOpenStatePocketMarketSellUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field bOpen boolean
---@field SellWidgetVM FB1PocketMarketSellWidgetVM
local FB1Packet_S_ChangeOpenStatePocketMarketSellUI = {}



---@class FB1Packet_S_ChangePossess : FB1PacketData
---@field EntityID FB1EntityId
---@field bAutonomyEnable boolean
---@field Datas TMap<FB1EntityId, FB1RelationshipData>
---@field bCloseMapMode boolean
---@field bSuccess boolean
local FB1Packet_S_ChangePossess = {}



---@class FB1Packet_S_ChangeScheduleState : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
---@field ScheduleControlState EB1ScheduleControlState
local FB1Packet_S_ChangeScheduleState = {}



---@class FB1Packet_S_ChangeSprint : FB1PacketData
---@field EntityID FB1EntityId
---@field bIsSprints TArray<boolean>
---@field SprintReasons TArray<EB1SprintReason>
local FB1Packet_S_ChangeSprint = {}



---@class FB1Packet_S_ChangeState : FB1PacketData
---@field EntityID FB1EntityId
---@field StateGroupId FName
---@field StateId FName
local FB1Packet_S_ChangeState = {}



---@class FB1Packet_S_ClearMovementData : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_ClearMovementData = {}



---@class FB1Packet_S_ClearOnScreenDebugMessages : FB1PacketData
local FB1Packet_S_ClearOnScreenDebugMessages = {}


---@class FB1Packet_S_CreateTransportSound : FB1PacketData
---@field TransportType FName
local FB1Packet_S_CreateTransportSound = {}



---@class FB1Packet_S_DespawnEntities : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
local FB1Packet_S_DespawnEntities = {}



---@class FB1Packet_S_DetachCarriableObject : FB1PacketData
---@field EntityID FB1EntityId
---@field SiteEntityId FB1EntityId
---@field ParentEntityId FB1EntityId
---@field SlotName FName
---@field Location FVector
---@field Rotation FRotator
local FB1Packet_S_DetachCarriableObject = {}



---@class FB1Packet_S_DetachCharacter : FB1PacketData
---@field ChildEntityId FB1EntityId
---@field Location FVector
---@field Rotation FRotator
local FB1Packet_S_DetachCharacter = {}



---@class FB1Packet_S_DetachFromCradle : FB1PacketData
---@field EntityID FB1EntityId
---@field CradleEntityId FB1EntityId
---@field Location FVector
local FB1Packet_S_DetachFromCradle = {}



---@class FB1Packet_S_DetachMesh : FB1PacketData
---@field EntityID FB1EntityId
---@field MeshId FName
local FB1Packet_S_DetachMesh = {}



---@class FB1Packet_S_DoorPermissionUpdated : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_DoorPermissionUpdated = {}



---@class FB1Packet_S_DrawDebugList : FB1PacketData
---@field LineInfos TArray<FB1DrawDebugLineParam>
---@field DirectionalInfos TArray<FB1DrawDebugDirectionalArrowParam>
---@field BoxInfos TArray<FB1DrawDebugBoxParam>
---@field CircleInfos TArray<FB1DrawDebugCircleParam>
---@field SphereInfos TArray<FB1DrawDebugSphereParam>
---@field PointInfos TArray<FB1DrawDebugPointParam>
---@field StringInfos TArray<FB1DrawDebugStringParam>
---@field CapsuleInfos TArray<FB1DrawDebugCapsuleParam>
---@field CircleArcInfos TArray<FB1DrawDebugCircleArcParam>
---@field CoordinateSystemInfos TArray<FB1DrawDebugCoordinateSystemParam>
---@field DebugCharacterInfos TArray<FB1DebugCharacterInfo>
---@field DebugGameObjectInfos TArray<FB1DebugGameObjectInfo>
---@field AddOnScreenDebugMessageInfos TArray<FB1AddOnScreenDebugMessageParam>
local FB1Packet_S_DrawDebugList = {}



---@class FB1Packet_S_EndAutoDriving : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_EndAutoDriving = {}



---@class FB1Packet_S_EndInit : FB1PacketData
---@field LevelName FName
local FB1Packet_S_EndInit = {}



---@class FB1Packet_S_EndSubAction : FB1PacketData
---@field EntityID FB1EntityId
---@field SubActionType EB1SubActionType
local FB1Packet_S_EndSubAction = {}



---@class FB1Packet_S_EnterPhotoMode : FB1PacketData
local FB1Packet_S_EnterPhotoMode = {}


---@class FB1Packet_S_EnterVehicle : FB1PacketData
---@field PassengerEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
---@field VehicleSeat EB1VehicleSeat
local FB1Packet_S_EnterVehicle = {}



---@class FB1Packet_S_ExitVehicle : FB1PacketData
---@field PassengerEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
---@field VehicleSeat EB1VehicleSeat
local FB1Packet_S_ExitVehicle = {}



---@class FB1Packet_S_FailEnterBuildMode : FB1PacketData
local FB1Packet_S_FailEnterBuildMode = {}


---@class FB1Packet_S_FinishAction : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_FinishAction = {}



---@class FB1Packet_S_FinishInteraction : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_FinishInteraction = {}



---@class FB1Packet_S_FinishInteractionBag : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueueId int64
local FB1Packet_S_FinishInteractionBag = {}



---@class FB1Packet_S_FinishPlayGeneratedMotion : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_FinishPlayGeneratedMotion = {}



---@class FB1Packet_S_FinishTalkNotify : FB1PacketData
---@field EntityID FB1EntityId
---@field bFullBody boolean
local FB1Packet_S_FinishTalkNotify = {}



---@class FB1Packet_S_FlushPersistentDebugLines : FB1PacketData
local FB1Packet_S_FlushPersistentDebugLines = {}


---@class FB1Packet_S_FlushPersistentDebugStrings : FB1PacketData
local FB1Packet_S_FlushPersistentDebugStrings = {}


---@class FB1Packet_S_ForceChangeFreeViewCameraMode : FB1PacketData
local FB1Packet_S_ForceChangeFreeViewCameraMode = {}


---@class FB1Packet_S_ForceFinishStaticMeshAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimId FName
---@field bReversePlay boolean
local FB1Packet_S_ForceFinishStaticMeshAnim = {}



---@class FB1Packet_S_ForceFinishVATAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimSequenceId FName
local FB1Packet_S_ForceFinishVATAnim = {}



---@class FB1Packet_S_ForceRemoveVehicleSeat : FB1PacketData
---@field VehicleId FB1EntityId
---@field EntityID FB1EntityId
local FB1Packet_S_ForceRemoveVehicleSeat = {}



---@class FB1Packet_S_ForcedPassengersExit : FB1PacketData
---@field VehicleEntityId FB1EntityId
local FB1Packet_S_ForcedPassengersExit = {}



---@class FB1Packet_S_HiddenGrabObject : FB1PacketData
---@field EntityID FB1EntityId
---@field IsOn boolean
---@field HiddenReason FName
local FB1Packet_S_HiddenGrabObject = {}



---@class FB1Packet_S_HideCoopSelectUI : FB1PacketData
---@field SelfEntityId FB1EntityId
local FB1Packet_S_HideCoopSelectUI = {}



---@class FB1Packet_S_HideDreamBubble : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_HideDreamBubble = {}



---@class FB1Packet_S_HideQuestUI : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_HideQuestUI = {}



---@class FB1Packet_S_HitByVehicle : FB1PacketData
---@field EntityID FB1EntityId
---@field Velocity FVector
local FB1Packet_S_HitByVehicle = {}



---@class FB1Packet_S_InheritVehicle : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field InheritorEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
local FB1Packet_S_InheritVehicle = {}



---@class FB1Packet_S_InitCityEdit : FB1PacketData
local FB1Packet_S_InitCityEdit = {}


---@class FB1Packet_S_InitDream : FB1PacketData
---@field EntityID FB1EntityId
---@field bDreaming boolean
---@field bREM boolean
---@field bSleepwalking boolean
---@field DreamPoolId FName
---@field DreamSequenceId FName
---@field SleepwalkInteractionBagId FName
local FB1Packet_S_InitDream = {}



---@class FB1Packet_S_InitFamilies : FB1PacketData
---@field FamilyEntityInfos TMap<FB1EntityId, FB1HouseholdInfo>
local FB1Packet_S_InitFamilies = {}



---@class FB1Packet_S_InitHouseholdMonitoring : FB1PacketData
---@field FamiilyEntityId FB1EntityId
---@field NotificationDataList TArray<FB1HouseholdMonitoringNotificationData>
---@field UnreadNotificationCount int32
local FB1Packet_S_InitHouseholdMonitoring = {}



---@class FB1Packet_S_InitSites : FB1PacketData
---@field SiteEntityInfos TMap<FName, FB1PacketInitSiteInfo>
local FB1Packet_S_InitSites = {}



---@class FB1Packet_S_InitStartTime : FB1PacketData
---@field BaseTime FDateTime
---@field CurrentTime FDateTime
local FB1Packet_S_InitStartTime = {}



---@class FB1Packet_S_InitTimeline : FB1PacketData
---@field EntityID FB1EntityId
---@field BaseTimelines TArray<FB1Timeline>
---@field OverrideTimelines TArray<FB1Timeline>
---@field CurrentScheduleId FB1ScheduleId
local FB1Packet_S_InitTimeline = {}



---@class FB1Packet_S_InstantiateTrafficLights : FB1PacketData
---@field TrafficLights TArray<FB1CityGraphTafficLight>
local FB1Packet_S_InstantiateTrafficLights = {}



---@class FB1Packet_S_JobInfo : FB1PacketData
---@field EntityID FB1EntityId
---@field CompanyEntityId FB1EntityId
---@field SeatEntityId FB1EntityId
---@field WorkState EB1WorkState
---@field StartWorkTicks int64
---@field EndWorkTicks int64
---@field ReserveJobPromotionData FB1JobSearchJobData
---@field JoinedJobInfo FB1JobInfo
---@field DepartmentKey FB1DepartmentKey
---@field CompanyDtId FName
local FB1Packet_S_JobInfo = {}



---@class FB1Packet_S_MissionCountUpdate : FB1PacketData
---@field EntityID FB1EntityId
---@field Count int64
local FB1Packet_S_MissionCountUpdate = {}



---@class FB1Packet_S_ModifyTemporaryAppearance : FB1PacketData
---@field EntityID FB1EntityId
---@field ChangeAppearanceKey FName
---@field ChangeAppearanceValue FName
---@field duration float
local FB1Packet_S_ModifyTemporaryAppearance = {}



---@class FB1Packet_S_ModifyTemporaryAppearanceHair : FB1PacketData
---@field EntityID FB1EntityId
---@field PartsKey FName
---@field ChangeAppearanceValue FName
---@field duration float
local FB1Packet_S_ModifyTemporaryAppearanceHair = {}



---@class FB1Packet_S_MoveInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueueId int64
---@field NewIndex int32
local FB1Packet_S_MoveInteraction = {}



---@class FB1Packet_S_MoveToWaitingArea : FB1PacketData
---@field EntityID FB1EntityId
---@field WaitLocation FVector
---@field NewNodeIndex int32
local FB1Packet_S_MoveToWaitingArea = {}



---@class FB1Packet_S_ObjectWeathingValue : FB1PacketData
---@field EntityID FB1EntityId
---@field WeatheringValue float
local FB1Packet_S_ObjectWeathingValue = {}



---@class FB1Packet_S_OnBecameGhost : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_OnBecameGhost = {}



---@class FB1Packet_S_OnBeginOverlap : FB1PacketData
---@field EntityID FB1EntityId
---@field OtherEntityId FB1EntityId
local FB1Packet_S_OnBeginOverlap = {}



---@class FB1Packet_S_OnChangeCurrentSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field CurrentScheduleId FB1ScheduleId
---@field bNeedUIRefresh boolean
local FB1Packet_S_OnChangeCurrentSchedule = {}



---@class FB1Packet_S_OnChangeCurrentTimelineName : FB1PacketData
---@field EntityID FB1EntityId
---@field TimelineName FName
local FB1Packet_S_OnChangeCurrentTimelineName = {}



---@class FB1Packet_S_OnChangeFloorLevel : FB1PacketData
---@field EntityID FB1EntityId
---@field FloorLevel int32
local FB1Packet_S_OnChangeFloorLevel = {}



---@class FB1Packet_S_OnChangeNavigationMethod : FB1PacketData
---@field EntityID FB1EntityId
---@field OldType EB1NavigationNodeType
---@field NewType EB1NavigationNodeType
---@field AdjustedLocation FVector
---@field PrevTarget FB1EntityId
---@field CurrentTarget FB1EntityId
---@field PathId uint32
---@field bSprint boolean
local FB1Packet_S_OnChangeNavigationMethod = {}



---@class FB1Packet_S_OnChangedDepartment : FB1PacketData
---@field CharacterId FB1EntityId
---@field SeatEntityId FB1EntityId
---@field PrevDepartmentKey FB1DepartmentKey
---@field NextDepartmentKey FB1DepartmentKey
local FB1Packet_S_OnChangedDepartment = {}



---@class FB1Packet_S_OnChangedGhostInteractionAvailability : FB1PacketData
---@field EntityID FB1EntityId
---@field bVisible boolean
local FB1Packet_S_OnChangedGhostInteractionAvailability = {}



---@class FB1Packet_S_OnChangedSimulationLevel : FB1PacketData
---@field SLODChangeInfoList TMap<EB2EntityType, FB1EntitySLODInfoMap>
local FB1Packet_S_OnChangedSimulationLevel = {}



---@class FB1Packet_S_OnCharacterEnterSite : FB1PacketData
---@field CharacterEntityId FB1EntityId
---@field SiteEntityId FB1EntityId
local FB1Packet_S_OnCharacterEnterSite = {}



---@class FB1Packet_S_OnCharacterLeaveSite : FB1PacketData
---@field CharacterEntityId FB1EntityId
---@field SiteEntityId FB1EntityId
local FB1Packet_S_OnCharacterLeaveSite = {}



---@class FB1Packet_S_OnCompleteHope : FB1PacketData
---@field EntityID FB1EntityId
---@field CompleteSlot int32
---@field UpdateHopeId FName
---@field EmotionId FName
local FB1Packet_S_OnCompleteHope = {}



---@class FB1Packet_S_OnDeathCharacter : FB1PacketData
---@field EntityID FB1EntityId
---@field LifeTriggerId FName
---@field bBecomeGhost boolean
---@field PopupId FName
---@field CharacterLastName FText
---@field CharacterFirstName FText
local FB1Packet_S_OnDeathCharacter = {}



---@class FB1Packet_S_OnEndDream : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_OnEndDream = {}



---@class FB1Packet_S_OnEndOverlap : FB1PacketData
---@field EntityID FB1EntityId
---@field OtherEntityId FB1EntityId
local FB1Packet_S_OnEndOverlap = {}



---@class FB1Packet_S_OnEndREM : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_OnEndREM = {}



---@class FB1Packet_S_OnEndSleepwalking : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_OnEndSleepwalking = {}



---@class FB1Packet_S_OnFinishPreferenceMission : FB1PacketData
---@field EntityID FB1EntityId
---@field PreferenceId FName
---@field AlertMessageId FName
---@field bLike boolean
local FB1Packet_S_OnFinishPreferenceMission = {}



---@class FB1Packet_S_OnHopeUpdate : FB1PacketData
---@field RefreshSlot int32
---@field bUpdateListView boolean
---@field bShowHopeAlert boolean
---@field UpdateHopeId FName
---@field NextUpdateTime int64
local FB1Packet_S_OnHopeUpdate = {}



---@class FB1Packet_S_OnJoinedCompany : FB1PacketData
---@field CharacterId FB1EntityId
---@field CompanyEntityId FB1EntityId
---@field SeatEntityId FB1EntityId
---@field DepartmentKey FB1DepartmentKey
---@field CompanyDtId FName
---@field JobInfo FB1JobInfo
local FB1Packet_S_OnJoinedCompany = {}



---@class FB1Packet_S_OnLeftCompany : FB1PacketData
---@field CharacterId FB1EntityId
---@field CompanyDtId FName
---@field LeaveCompanyReason EB1LeaveCompanyReason
---@field DepartmentKey FB1DepartmentKey
local FB1Packet_S_OnLeftCompany = {}



---@class FB1Packet_S_OnMessageAdded : FB1PacketData
---@field MessageOwner FB1EntityId
---@field Partner FB1EntityId
---@field SenderSystem FName
---@field Message FB1MobileMessage
local FB1Packet_S_OnMessageAdded = {}



---@class FB1Packet_S_OnMessageRead : FB1PacketData
---@field MessageOwner FB1EntityId
local FB1Packet_S_OnMessageRead = {}



---@class FB1Packet_S_OnPocketMarketFollowerChanged : FB1PacketData
---@field EntityID FB1EntityId
---@field PocketMarketFollwer int32
---@field PocketMarketGrade EB1PocketMarketGrade
local FB1Packet_S_OnPocketMarketFollowerChanged = {}



---@class FB1Packet_S_OnStartDream : FB1PacketData
---@field EntityID FB1EntityId
---@field DreamPoolId FName
local FB1Packet_S_OnStartDream = {}



---@class FB1Packet_S_OnStartREM : FB1PacketData
---@field EntityID FB1EntityId
---@field DreamSequenceId FName
local FB1Packet_S_OnStartREM = {}



---@class FB1Packet_S_OnStartSleepwalking : FB1PacketData
---@field EntityID FB1EntityId
---@field SleepwalkInteractionBagId FName
local FB1Packet_S_OnStartSleepwalking = {}



---@class FB1Packet_S_OnTaxMessageAdded : FB1PacketData
---@field MessageOwner FB1EntityId
local FB1Packet_S_OnTaxMessageAdded = {}



---@class FB1Packet_S_OnWaitingMessageRevealed : FB1PacketData
---@field MessageOwner FB1EntityId
---@field Partner FB1EntityId
---@field SenderSystem FName
---@field bIsWait boolean
local FB1Packet_S_OnWaitingMessageRevealed = {}



---@class FB1Packet_S_OpenBabyReturnToHomePopup : FB1PacketData
---@field PopupId FName
---@field BabiesIdList TArray<FB1EntityId>
local FB1Packet_S_OpenBabyReturnToHomePopup = {}



---@class FB1Packet_S_OpenCatOperatorAlert : FB1PacketData
---@field MessageId FString
---@field EntityID FB1EntityId
local FB1Packet_S_OpenCatOperatorAlert = {}



---@class FB1Packet_S_OpenCharacterArrivedPopup : FB1PacketData
---@field PopupId FName
---@field SelfEntityId FB1EntityId
---@field BaseEntityId FB1EntityId
---@field SelfLastName FText
---@field SelfFirstName FText
---@field BaseLastName FText
---@field BaseFirstName FText
---@field ExecuteInteractionBagId FName
local FB1Packet_S_OpenCharacterArrivedPopup = {}



---@class FB1Packet_S_OpenChildBirthPopup : FB1PacketData
---@field PopupId FName
---@field SelfEntityId FB1EntityId
---@field SelfLastName FText
---@field SelfFirstName FText
---@field PartnerLastName FText
---@field PartnerFirstName FText
---@field SelfGender EB1GenderType
local FB1Packet_S_OpenChildBirthPopup = {}



---@class FB1Packet_S_OpenChoiceCardPopup : FB1PacketData
---@field ReceiveEntityId FB1EntityId
---@field SendEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field ChoiceCardId FName
local FB1Packet_S_OpenChoiceCardPopup = {}



---@class FB1Packet_S_OpenCoopSelectUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field CoopId FName
---@field InteractionBagId FName
---@field CandidateList TArray<FB1EntityId>
local FB1Packet_S_OpenCoopSelectUI = {}



---@class FB1Packet_S_OpenCraftingUI : FB1PacketData
---@field EntityID FB1EntityId
---@field WorkbenchEntityId FB1EntityId
---@field CraftingId FName
---@field RecipeVMs TMap<FName, FB1CraftingRecipeVMs>
---@field IngredientInfos TArray<FB1CraftingIngredient>
local FB1Packet_S_OpenCraftingUI = {}



---@class FB1Packet_S_OpenCreateSocialEventPopup : FB1PacketData
---@field HostEntityId FB1EntityId
---@field EventStartTime int64
---@field FocusCategory FName
---@field SocialEventDataMap TMap<FName, FB1SiteEventSettingParam>
local FB1Packet_S_OpenCreateSocialEventPopup = {}



---@class FB1Packet_S_OpenGhostPlayPopup : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_OpenGhostPlayPopup = {}



---@class FB1Packet_S_OpenLifePopup : FB1PacketData
---@field PopupId FName
---@field LifeTriggerId FName
---@field BaseLastName FText
---@field BaseFirstName FText
---@field IsDeathTrigger boolean
local FB1Packet_S_OpenLifePopup = {}



---@class FB1Packet_S_OpenMoveToMapPopup : FB1PacketData
---@field PopupId FName
local FB1Packet_S_OpenMoveToMapPopup = {}



---@class FB1Packet_S_OpenPopup : FB1PacketData
---@field PopupId FName
---@field BaseLastName FText
---@field BaseFirstName FText
---@field TargetLastName FText
---@field TargetFirstName FText
local FB1Packet_S_OpenPopup = {}



---@class FB1Packet_S_OpenPopupAction : FB1PacketData
---@field PopupId FName
---@field BaseEntityId FB1EntityId
---@field BaseLastName FText
---@field BaseFirstName FText
---@field TargetLastName FText
---@field TargetFirstName FText
local FB1Packet_S_OpenPopupAction = {}



---@class FB1Packet_S_OpenSelectSlotOwnershipUI : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionBagId FName
local FB1Packet_S_OpenSelectSlotOwnershipUI = {}



---@class FB1Packet_S_OpenSocialEventEndPopup : FB1PacketData
---@field EventName FText
local FB1Packet_S_OpenSocialEventEndPopup = {}



---@class FB1Packet_S_OpenSocialEventStartPopup : FB1PacketData
---@field EventName FText
---@field EventStartTime int32
---@field EventEndTime int32
local FB1Packet_S_OpenSocialEventStartPopup = {}



---@class FB1Packet_S_OpenUI : FB1PacketData
---@field UIType EB1UIType
---@field TargetLocation FVector
---@field EntityID FB1EntityId
local FB1Packet_S_OpenUI = {}



---@class FB1Packet_S_PausePathFollowing : FB1PacketData
---@field EntityID FB1EntityId
---@field bPause boolean
---@field Reason EB1PathFollowingPasue
local FB1Packet_S_PausePathFollowing = {}



---@class FB1Packet_S_PauseSlotLayer : FB1PacketData
---@field EntityID FB1EntityId
---@field bPauseSlotLayer boolean
local FB1Packet_S_PauseSlotLayer = {}



---@class FB1Packet_S_PickRandomAnswer : FB1PacketData
---@field AnswerTitleStrId FString
---@field AnswerDescStrId FString
---@field AnswerButtonStrId FString
---@field ColorId FName
local FB1Packet_S_PickRandomAnswer = {}



---@class FB1Packet_S_PlayAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimId FName
---@field ActionOwnerEntityId FB1EntityId
---@field ActionTargetEntityId FB1EntityId
---@field StartSectionName FName
---@field AnimTag FName
---@field Position float
---@field bWithMotionWarp boolean
local FB1Packet_S_PlayAnim = {}



---@class FB1Packet_S_PlayFx : FB1PacketData
---@field EntityID FB1EntityId
---@field FxId FName
local FB1Packet_S_PlayFx = {}



---@class FB1Packet_S_PlayGeneratedMotion : FB1PacketData
---@field EntityID FB1EntityId
---@field FileKey FString
---@field CurrentAnimTime float
local FB1Packet_S_PlayGeneratedMotion = {}



---@class FB1Packet_S_PlayLevelSequence : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field LevelSeqeunceId FName
local FB1Packet_S_PlayLevelSequence = {}



---@class FB1Packet_S_PlayPP : FB1PacketData
---@field EntityID FB1EntityId
---@field PPId FName
local FB1Packet_S_PlayPP = {}



---@class FB1Packet_S_PlaySound2D : FB1PacketData
---@field SoundId FName
local FB1Packet_S_PlaySound2D = {}



---@class FB1Packet_S_PlayStaticMeshAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimId FName
---@field Position float
---@field bReversePlay boolean
local FB1Packet_S_PlayStaticMeshAnim = {}



---@class FB1Packet_S_PlaySubAction : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field AnimId FName
---@field DataId FName
---@field AnimType EB1ReactionAnimType
---@field SubActionType EB1SubActionType
---@field AnimStartPos float
local FB1Packet_S_PlaySubAction = {}



---@class FB1Packet_S_PlayTalkNotify : FB1PacketData
---@field EntityID FB1EntityId
---@field bFullBody boolean
local FB1Packet_S_PlayTalkNotify = {}



---@class FB1Packet_S_PlayVATAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimSequenceId FName
---@field Position float
local FB1Packet_S_PlayVATAnim = {}



---@class FB1Packet_S_PlayVideoAction : FB1PacketData
---@field VideoPlayerId EB1VideoPlayerId
---@field EntityID FB1EntityId
local FB1Packet_S_PlayVideoAction = {}



---@class FB1Packet_S_PossessInfo : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_PossessInfo = {}



---@class FB1Packet_S_RefreshAppearance : FB1PacketData
---@field EntityID FB1EntityId
---@field AppearanceSetting FB1AppearanceSetting
---@field bIsChangedOutfitOnly boolean
local FB1Packet_S_RefreshAppearance = {}



---@class FB1Packet_S_RefreshPocketMarketGrade : FB1PacketData
local FB1Packet_S_RefreshPocketMarketGrade = {}


---@class FB1Packet_S_RefreshPurchasedShoppingItems : FB1PacketData
---@field PurchasedShoppingItems TArray<FB1PocketMarketPurchasedShoppingItem>
local FB1Packet_S_RefreshPurchasedShoppingItems = {}



---@class FB1Packet_S_RefreshSellItems : FB1PacketData
---@field CharacterSellingItems TArray<FB1PocketMarketSellItem>
local FB1Packet_S_RefreshSellItems = {}



---@class FB1Packet_S_RefreshShoppingItems : FB1PacketData
---@field CategoryShoppingItems TMap<FName, FB1PocketMarketShoppingItemsWrapper>
local FB1Packet_S_RefreshShoppingItems = {}



---@class FB1Packet_S_Refresh_WalkTo : FB1PacketData
---@field EntityID FB1EntityId
---@field Location FVector
---@field Rotation FRotator
---@field Nodes TArray<FB1NavigationNode>
---@field CrossWalkNodes TArray<int32>
---@field CurrentNodeIndex int32
---@field AcceptanceRadius float
---@field PathId uint32
---@field PauseReason TSet<EB1PathFollowingPasue>
---@field Reason FName
local FB1Packet_S_Refresh_WalkTo = {}



---@class FB1Packet_S_RegisterVehicleSuccess : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
local FB1Packet_S_RegisterVehicleSuccess = {}



---@class FB1Packet_S_RemoveBuff : FB1PacketData
---@field EntityID FB1EntityId
---@field BuffId FName
---@field IsCanceled boolean
local FB1Packet_S_RemoveBuff = {}



---@class FB1Packet_S_RemoveHouseholdInfo : FB1PacketData
---@field HouseholdEntityId FB1EntityId
local FB1Packet_S_RemoveHouseholdInfo = {}



---@class FB1Packet_S_RemoveInteractionQueue : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionQueueId int64
---@field RemainInteractionQueueCount int32
local FB1Packet_S_RemoveInteractionQueue = {}



---@class FB1Packet_S_RemoveMoveTogetherVM : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_RemoveMoveTogetherVM = {}



---@class FB1Packet_S_RemoveSpeechBubble : FB1PacketData
---@field EntityID FB1EntityId
---@field SpeechBubbleId FName
local FB1Packet_S_RemoveSpeechBubble = {}



---@class FB1Packet_S_RemoveTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitId FName
---@field bIsHopeLifeTrait boolean
local FB1Packet_S_RemoveTrait = {}



---@class FB1Packet_S_RemoveTransportSound : FB1PacketData
local FB1Packet_S_RemoveTransportSound = {}


---@class FB1Packet_S_RemoveWallsSite : FB1PacketData
---@field SiteId FName
local FB1Packet_S_RemoveWallsSite = {}



---@class FB1Packet_S_ReplyRecruitInfos : FB1PacketData
---@field RecruitInfos TArray<FB1ShowRecruitInfo>
local FB1Packet_S_ReplyRecruitInfos = {}



---@class FB1Packet_S_RequestAllGeneratedMotionSlotData : FB1PacketData
local FB1Packet_S_RequestAllGeneratedMotionSlotData = {}


---@class FB1Packet_S_RequestAsyncLoad : FB1PacketData
---@field RequestAsyncLoadList TArray<FB1RequestAsyncLoad>
local FB1Packet_S_RequestAsyncLoad = {}



---@class FB1Packet_S_RequestCheckAvailableFirePos : FB1PacketData
---@field RequestList TArray<FB2SiteCheckAvailableFirePosParam>
local FB1Packet_S_RequestCheckAvailableFirePos = {}



---@class FB1Packet_S_RequestMotionWarping : FB1PacketData
---@field EntityID FB1EntityId
---@field StartLocation FVector
---@field StartRotation FQuat
---@field EndLocation FVector
---@field EndRotation FQuat
---@field MontageId FName
---@field TotalTime float
---@field BlendTime float
---@field AccTime float
---@field BlendAlpha float
local FB1Packet_S_RequestMotionWarping = {}



---@class FB1Packet_S_RequestUpdateAging : FB1PacketData
---@field EntityID FB1EntityId
---@field CurrentGrowthStep EB1GrowthStep
---@field InheritedPerspectiveId FName
local FB1Packet_S_RequestUpdateAging = {}



---@class FB1Packet_S_RequestUpdateBuildMode : FB1PacketData
---@field SiteId FName
---@field bRequestBuiltDataPacket boolean
local FB1Packet_S_RequestUpdateBuildMode = {}



---@class FB1Packet_S_RequestUpdateQuestUI : FB1PacketData
---@field EntityID FB1EntityId
---@field InUpdateQuestList TArray<FB1UpdateQuest>
local FB1Packet_S_RequestUpdateQuestUI = {}



---@class FB1Packet_S_RequestUsingLadder : FB1PacketData
---@field EntityID FB1EntityId
---@field Context FB1LadderContext
local FB1Packet_S_RequestUsingLadder = {}



---@class FB1Packet_S_RescueCharacter : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
---@field bFadeProcess boolean
---@field bSendToastMessage boolean
local FB1Packet_S_RescueCharacter = {}



---@class FB1Packet_S_RescueCradleOnBuildMode : FB1PacketData
---@field CradleEntityId FB1EntityId
---@field CradleLocation FVector
---@field CradleRotation FRotator
---@field CradleFloorLevel int32
local FB1Packet_S_RescueCradleOnBuildMode = {}



---@class FB1Packet_S_ResetCurrentSocialEventData : FB1PacketData
local FB1Packet_S_ResetCurrentSocialEventData = {}


---@class FB1Packet_S_ResetSite : FB1PacketData
---@field SiteId FName
---@field SiteEntityInfo FB1PacketInitSiteInfo
local FB1Packet_S_ResetSite = {}



---@class FB1Packet_S_ResetTrait : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_ResetTrait = {}



---@class FB1Packet_S_ResponseAddProfileUnlockHistory : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field UnlockHistories TSet<EB1RelationshipProfileType>
local FB1Packet_S_ResponseAddProfileUnlockHistory = {}



---@class FB1Packet_S_ResponseAddRelationshipRecordData : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field RecordId FName
local FB1Packet_S_ResponseAddRelationshipRecordData = {}



---@class FB1Packet_S_ResponseAddSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field NewSchedule FB1Schedule
local FB1Packet_S_ResponseAddSchedule = {}



---@class FB1Packet_S_ResponseApplyJobFireCharacter : FB1PacketData
---@field RequestEntityId FB1EntityId
---@field CompanyEntityId FB1EntityId
---@field DepartmentKey FB1DepartmentKey
---@field bNewEmployment boolean
---@field FireEntityHouseholdName FText
---@field FireEntityFirstName FText
---@field FireEntityLastName FText
local FB1Packet_S_ResponseApplyJobFireCharacter = {}



---@class FB1Packet_S_ResponseAvailableInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field ImpactLocation FVector
---@field AvailableInteractionBagList TArray<FB1AvailableInteractionBagData>
---@field CategoryNameId FString
---@field IsDisplayObjectName boolean
---@field ObjectExchangeCost int64
---@field ObjectExchangeCostInSite int64
local FB1Packet_S_ResponseAvailableInteractionBagList = {}



---@class FB1Packet_S_ResponseAvailableRabbitHoleInteractionIdList : FB1PacketData
---@field EntityID FB1EntityId
---@field RabbitHoleInteractionIdList TArray<FName>
local FB1Packet_S_ResponseAvailableRabbitHoleInteractionIdList = {}



---@class FB1Packet_S_ResponseAvailableRemoteSelections : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field AvailableRemoteSelections TArray<FB1RemoteSelection>
---@field IsDisplayObjectName boolean
local FB1Packet_S_ResponseAvailableRemoteSelections = {}



---@class FB1Packet_S_ResponseAvailableTalkInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field RelationshipData FB1RelationshipData
---@field TalkSelectionRelationshipData TArray<FB1TalkSelectionRelationshipData>
---@field AvailableTalkSelectionIds TArray<FName>
---@field AvailableTalkInteractionBagIds TArray<FName>
local FB1Packet_S_ResponseAvailableTalkInteractionBagList = {}



---@class FB1Packet_S_ResponseAvailableVehicleInteractionBagList : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field AvailableInteractionBagDataList TArray<FB1AvailableInteractionBagData>
local FB1Packet_S_ResponseAvailableVehicleInteractionBagList = {}



---@class FB1Packet_S_ResponseCanAddInteraction : FB1PacketData
---@field RequestEntityId FB1EntityId
---@field Result EB1AddInteractionQueueResult
---@field bIsClick boolean
local FB1Packet_S_ResponseCanAddInteraction = {}



---@class FB1Packet_S_ResponseCanSaveGameObject : FB1PacketData
---@field Response EB1HouseholdMoveObjectSaveResponseType
local FB1Packet_S_ResponseCanSaveGameObject = {}



---@class FB1Packet_S_ResponseCheckDoorPermission : FB1PacketData
---@field CheckResults TMap<FB1EntityId, boolean>
---@field TargetEntityId FB1EntityId
local FB1Packet_S_ResponseCheckDoorPermission = {}



---@class FB1Packet_S_ResponseCheckObjectSkillConditionList : FB1PacketData
---@field ResultList TMap<FName, boolean>
local FB1Packet_S_ResponseCheckObjectSkillConditionList = {}



---@class FB1Packet_S_ResponseCheckWalkableGround : FB1PacketData
---@field EntityID FB1EntityId
---@field ImpactPoint FVector
---@field bIsWalkable boolean
local FB1Packet_S_ResponseCheckWalkableGround = {}



---@class FB1Packet_S_ResponseDepreciatedValue : FB1PacketData
---@field DepreciatedValue int64
---@field bResult boolean
local FB1Packet_S_ResponseDepreciatedValue = {}



---@class FB1Packet_S_ResponseDespawnVehicle : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_ResponseDespawnVehicle = {}



---@class FB1Packet_S_ResponseDoorToggleCheckPermission : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field bShowNoPermissionMsg boolean
---@field bResult boolean
---@field FailReason EB1DoorPermissionCheckFailReason
---@field bOpen boolean
local FB1Packet_S_ResponseDoorToggleCheckPermission = {}



---@class FB1Packet_S_ResponseIsReachableAutoDrive : FB1PacketData
---@field bResult boolean
local FB1Packet_S_ResponseIsReachableAutoDrive = {}



---@class FB1Packet_S_ResponseNearestCityGraphPoint : FB1PacketData
---@field Result FB1CityGraphPoint
---@field bMustUsePortal boolean
local FB1Packet_S_ResponseNearestCityGraphPoint = {}



---@class FB1Packet_S_ResponseNewUnlockList : FB1PacketData
---@field OwnerId FB1EntityId
---@field TargetId FB1EntityId
---@field UnlockList TSet<EB1RelationshipProfileType>
local FB1Packet_S_ResponseNewUnlockList = {}



---@class FB1Packet_S_ResponseQueryNavigationSkippable : FB1PacketData
---@field EntityID FB1EntityId
---@field Result EB1VehicleNavigationSkipResult
---@field Location FVector
---@field bNeedShowWidget boolean
local FB1Packet_S_ResponseQueryNavigationSkippable = {}



---@class FB1Packet_S_ResponseRemoveSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
local FB1Packet_S_ResponseRemoveSchedule = {}



---@class FB1Packet_S_ResponseSkipNavigation : FB1PacketData
---@field EntityID FB1EntityId
---@field Result EB1VehicleNavigationSkipResult
local FB1Packet_S_ResponseSkipNavigation = {}



---@class FB1Packet_S_ResponseSocialEventRoleSelectableRelationshipData : FB1PacketData
---@field RoleId FName
---@field RoleSelectableEntityIdList TArray<FB1EntityId>
local FB1Packet_S_ResponseSocialEventRoleSelectableRelationshipData = {}



---@class FB1Packet_S_ResponseSpawnVehicle : FB1PacketData
---@field EntityID FB1EntityId
---@field Transform FTransform
local FB1Packet_S_ResponseSpawnVehicle = {}



---@class FB1Packet_S_ResponseUpdateDoorPermission : FB1PacketData
---@field DoorEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field TargetResult boolean
---@field OverlappingResults TMap<FB1EntityId, boolean>
local FB1Packet_S_ResponseUpdateDoorPermission = {}



---@class FB1Packet_S_ResponseUpdateSchedule : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field ScheduleId FB1ScheduleId
---@field Schedule FB1Schedule
local FB1Packet_S_ResponseUpdateSchedule = {}



---@class FB1Packet_S_ResponseUpdatedGeneratedMotionSlotData : FB1PacketData
local FB1Packet_S_ResponseUpdatedGeneratedMotionSlotData = {}


---@class FB1Packet_S_ResultJobInducementAlert : FB1PacketData
---@field CharacterId FB1EntityId
local FB1Packet_S_ResultJobInducementAlert = {}



---@class FB1Packet_S_ReturnToParkingPlace : FB1PacketData
---@field EntityID FB1EntityId
---@field Transform FTransform
local FB1Packet_S_ReturnToParkingPlace = {}



---@class FB1Packet_S_RevertTemporaryAppearance : FB1PacketData
---@field EntityID FB1EntityId
---@field ChangeAppearanceKey FName
local FB1Packet_S_RevertTemporaryAppearance = {}



---@class FB1Packet_S_SendCareerList : FB1PacketData
---@field EntityID FB1EntityId
---@field JobInfos TArray<FB1JobInfo>
local FB1Packet_S_SendCareerList = {}



---@class FB1Packet_S_SendJobRankMessage : FB1PacketData
---@field EntityID FB1EntityId
---@field AlertType EB1AlertType
---@field CompanyDtId FName
---@field JobId FName
---@field Rank int32
local FB1Packet_S_SendJobRankMessage = {}



---@class FB1Packet_S_SendMessage : FB1PacketData
---@field EntityID FB1EntityId
---@field AlertType EB1AlertType
---@field MessageId FName
---@field Value int32
---@field SenderId FB1EntityId
local FB1Packet_S_SendMessage = {}



---@class FB1Packet_S_SendMobileToastMessage : FB1PacketData
---@field ToastMessageId FString
---@field UIType EB1UIType
local FB1Packet_S_SendMobileToastMessage = {}



---@class FB1Packet_S_SendRemoveRelationshipData : FB1PacketData
---@field TargetId FB1EntityId
local FB1Packet_S_SendRemoveRelationshipData = {}



---@class FB1Packet_S_SendToastMessage : FB1PacketData
---@field ToastMessageId FString
---@field LifeTime float
---@field bImmediateDisplay boolean
local FB1Packet_S_SendToastMessage = {}



---@class FB1Packet_S_SendToastMessageByText : FB1PacketData
---@field ToastMessageText FText
---@field LifeTime float
---@field bImmediateDisplay boolean
local FB1Packet_S_SendToastMessageByText = {}



---@class FB1Packet_S_SendUpdateJobPromotion : FB1PacketData
---@field CharacterId FB1EntityId
---@field JobSearchJobData FB1JobSearchJobData
---@field bApplyJobPromotion boolean
local FB1Packet_S_SendUpdateJobPromotion = {}



---@class FB1Packet_S_SetCharacterHidden : FB1PacketData
---@field EntityID FB1EntityId
---@field bHidden boolean
local FB1Packet_S_SetCharacterHidden = {}



---@class FB1Packet_S_SetClothWeatheringIntensity : FB1PacketData
---@field EntityID FB1EntityId
---@field ClothWeatheringIntensity float
local FB1Packet_S_SetClothWeatheringIntensity = {}



---@class FB1Packet_S_SetDebugMessageUI : FB1PacketData
---@field bShow boolean
---@field DebugMessage FString
local FB1Packet_S_SetDebugMessageUI = {}



---@class FB1Packet_S_SetDustyValue : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_SetDustyValue = {}



---@class FB1Packet_S_SetInvisible : FB1PacketData
---@field EntityID FB1EntityId
---@field Invisible boolean
---@field Reason FName
local FB1Packet_S_SetInvisible = {}



---@class FB1Packet_S_SetIsLastCheckConditionSuccess : FB1PacketData
---@field EntityID FB1EntityId
---@field TraitEntryType EB1TraitEntryType
---@field ParentTraitId FName
---@field bIsLastCheckConditionSuccess boolean
local FB1Packet_S_SetIsLastCheckConditionSuccess = {}



---@class FB1Packet_S_SetMeshVisibility : FB1PacketData
---@field EntityID FB1EntityId
---@field bVisible boolean
---@field bAffectAll boolean
local FB1Packet_S_SetMeshVisibility = {}



---@class FB1Packet_S_SetPreferenceByTrait : FB1PacketData
---@field EntityID FB1EntityId
---@field RelatedPreferenceIdList TArray<FName>
local FB1Packet_S_SetPreferenceByTrait = {}



---@class FB1Packet_S_SetSiteOwnerHouseholdId : FB1PacketData
---@field SiteId FName
---@field OwnerHouseholdEntityId FB1EntityId
local FB1Packet_S_SetSiteOwnerHouseholdId = {}



---@class FB1Packet_S_SetSkillLevel : FB1PacketData
---@field EntityID FB1EntityId
---@field SkillLevel int32
---@field InExperience float
---@field InSkillName FName
---@field bIsSkillLevelUp boolean
---@field StartRatio float
---@field GoalRatio float
local FB1Packet_S_SetSkillLevel = {}



---@class FB1Packet_S_SetSpeechBubbleTalking : FB1PacketData
---@field EntityID FB1EntityId
---@field IsOn boolean
local FB1Packet_S_SetSpeechBubbleTalking = {}



---@class FB1Packet_S_SetVehicleControlSubject : FB1PacketData
---@field EntityID FB1EntityId
---@field ControlSubject EB1VehicleControlSubject
local FB1Packet_S_SetVehicleControlSubject = {}



---@class FB1Packet_S_SetVehicleLightsFlag : FB1PacketData
---@field EntityID FB1EntityId
---@field VehicleLightsFlag EB1VehicleLight
local FB1Packet_S_SetVehicleLightsFlag = {}



---@class FB1Packet_S_SetVehicleMovableFlag : FB1PacketData
---@field EntityID FB1EntityId
---@field Flag EB1VehicleMovableFlag
local FB1Packet_S_SetVehicleMovableFlag = {}



---@class FB1Packet_S_ShowDivorcePopup : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
local FB1Packet_S_ShowDivorcePopup = {}



---@class FB1Packet_S_ShowDreamBubble : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_ShowDreamBubble = {}



---@class FB1Packet_S_ShowMarriageFamilyMovePopup : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
local FB1Packet_S_ShowMarriageFamilyMovePopup = {}



---@class FB1Packet_S_ShowMarriagePopup : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
local FB1Packet_S_ShowMarriagePopup = {}



---@class FB1Packet_S_ShowQuestUI : FB1PacketData
---@field EntityID FB1EntityId
---@field InHistoryDataMap TMap<FName, FB1QuestHistoryData>
local FB1Packet_S_ShowQuestUI = {}



---@class FB1Packet_S_SmartZoiActiveChanged : FB1PacketData
---@field bIsOn boolean
local FB1Packet_S_SmartZoiActiveChanged = {}



---@class FB1Packet_S_Snapshot : FB1PacketData
---@field FolderName FString
---@field Filename FString
---@field SlotName FString
---@field bIsSuccess boolean
---@field bUsePopup boolean
---@field Crc32 uint32
---@field FileSize uint32
local FB1Packet_S_Snapshot = {}



---@class FB1Packet_S_SootDecalActive : FB1PacketData
---@field EntityID FB1EntityId
---@field bNeedDelay boolean
local FB1Packet_S_SootDecalActive = {}



---@class FB1Packet_S_SpawnDustyObject : FB1PacketData
---@field EntityID FB1EntityId
---@field SiteEntityId FB1EntityId
---@field DustyValue float
---@field SpawnLocation FVector
local FB1Packet_S_SpawnDustyObject = {}



---@class FB1Packet_S_SpawnEntities : FB1PacketData
---@field Characters TArray<FB1CharacterSpawnInfo>
---@field GameObjects TArray<FB1GameObjectSpawnInfo>
---@field Vehicles TArray<FB1VehicleSpawnInfo>
---@field Spawners TArray<FB1SpawnerSpawnInfo>
---@field bGameObjectSyncSpawn boolean
local FB1Packet_S_SpawnEntities = {}



---@class FB1Packet_S_SpawnMeshToMeshSpawner : FB1PacketData
---@field EntityID FB1EntityId
---@field MeshDescriptionIdList TArray<FName>
---@field bVisibility boolean
local FB1Packet_S_SpawnMeshToMeshSpawner = {}



---@class FB1Packet_S_StartAction : FB1PacketData
---@field EntityID FB1EntityId
---@field ActionProgressTime float
local FB1Packet_S_StartAction = {}



---@class FB1Packet_S_StartActionGenerateMotion : FB1PacketData
---@field RequestEntityId FB1EntityId
local FB1Packet_S_StartActionGenerateMotion = {}



---@class FB1Packet_S_StartAutoDriving : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_StartAutoDriving = {}



---@class FB1Packet_S_StartBuildMode : FB1PacketData
---@field LastEntityId int64
---@field SiteEntireSaveData FB2SiteEntireSaveData
local FB1Packet_S_StartBuildMode = {}



---@class FB1Packet_S_StartCharacterCustomization : FB1PacketData
---@field EntityID FB1EntityId
---@field CategoryType EB1CharacterCustomizationCategory
local FB1Packet_S_StartCharacterCustomization = {}



---@class FB1Packet_S_StartCoop : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionDtId FName
local FB1Packet_S_StartCoop = {}



---@class FB1Packet_S_StartInit : FB1PacketData
---@field LevelName FName
local FB1Packet_S_StartInit = {}



---@class FB1Packet_S_StartInteraction : FB1PacketData
---@field EntityID FB1EntityId
---@field TargetEntityId FB1EntityId
---@field InteractionDtId FName
---@field TargetInteractionSlotName FName
---@field TotalProgressTime float
local FB1Packet_S_StartInteraction = {}



---@class FB1Packet_S_StartInteractionBag : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionBagId FName
---@field InteractionQueueId int64
local FB1Packet_S_StartInteractionBag = {}



---@class FB1Packet_S_StartKarmaInvolving : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_StartKarmaInvolving = {}



---@class FB1Packet_S_StartTakePicture : FB1PacketData
---@field RequestEntityId FB1EntityId
---@field PhotoMode EB1BaseObject
local FB1Packet_S_StartTakePicture = {}



---@class FB1Packet_S_StopAllAnim : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_StopAllAnim = {}



---@class FB1Packet_S_StopAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field ActionOwnerEntityId FB1EntityId
---@field AnimId FName
local FB1Packet_S_StopAnim = {}



---@class FB1Packet_S_StopStaticMeshAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimId FName
local FB1Packet_S_StopStaticMeshAnim = {}



---@class FB1Packet_S_StopVATAnim : FB1PacketData
---@field EntityID FB1EntityId
---@field AnimSequenceId FName
local FB1Packet_S_StopVATAnim = {}



---@class FB1Packet_S_SuccessEvictFamilyFromSite : FB1PacketData
---@field SiteId FName
---@field OwnerHouseholdEntityId FB1EntityId
local FB1Packet_S_SuccessEvictFamilyFromSite = {}



---@class FB1Packet_S_SuccessInitDefaultSiteByReset : FB1PacketData
---@field SiteId FName
local FB1Packet_S_SuccessInitDefaultSiteByReset = {}



---@class FB1Packet_S_SuccessMoveInFamilyToSite : FB1PacketData
---@field SiteId FName
---@field OwnerHouseholdEntityId FB1EntityId
---@field bPossess boolean
---@field bPlayInitalStartVideo boolean
local FB1Packet_S_SuccessMoveInFamilyToSite = {}



---@class FB1Packet_S_SuccessRegisterCustomizedHousehold : FB1PacketData
---@field CurrentRegisteredHouseholdEntityId FB1EntityId
local FB1Packet_S_SuccessRegisterCustomizedHousehold = {}



---@class FB1Packet_S_SuccessVehiclePurchase : FB1PacketData
---@field EntityID FB1EntityId
---@field VehicleDtId FName
local FB1Packet_S_SuccessVehiclePurchase = {}



---@class FB1Packet_S_SyncCurrentTime : FB1PacketData
---@field CurrentTime FDateTime
---@field DeltaTimeForRealTime float
local FB1Packet_S_SyncCurrentTime = {}



---@class FB1Packet_S_SyncInteractionQueueProgress : FB1PacketData
---@field EntityID FB1EntityId
---@field CurrentProgressTime float
---@field TotalProgressTime float
local FB1Packet_S_SyncInteractionQueueProgress = {}



---@class FB1Packet_S_SyncNavigationNode : FB1PacketData
---@field EntityID FB1EntityId
---@field NodeIndex int32
---@field Node FB1NavigationNode
---@field Reason FName
local FB1Packet_S_SyncNavigationNode = {}



---@class FB1Packet_S_Teleport : FB1PacketData
---@field EntityID FB1EntityId
---@field Pos FVector
---@field Rot FRotator
local FB1Packet_S_Teleport = {}



---@class FB1Packet_S_TryVehicleAvoidance : FB1PacketData
---@field EntityID FB1EntityId
---@field NewNodes TArray<FB1NavigationNode>
local FB1Packet_S_TryVehicleAvoidance = {}



---@class FB1Packet_S_UnregisterVehicleSuccess : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field VehicleEntityId FB1EntityId
local FB1Packet_S_UnregisterVehicleSuccess = {}



---@class FB1Packet_S_UpdateAOIEntity : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
local FB1Packet_S_UpdateAOIEntity = {}



---@class FB1Packet_S_UpdateActionPlayerInfo : FB1PacketData
---@field ActionPlayerInfoStr FString
local FB1Packet_S_UpdateActionPlayerInfo = {}



---@class FB1Packet_S_UpdateActiveEvent : FB1PacketData
---@field EntityID FB1EntityId
---@field InteractionBagId FName
local FB1Packet_S_UpdateActiveEvent = {}



---@class FB1Packet_S_UpdateAge : FB1PacketData
---@field EntityID FB1EntityId
---@field Age int32
local FB1Packet_S_UpdateAge = {}



---@class FB1Packet_S_UpdateAgeByCheat : FB1PacketData
---@field EntityID FB1EntityId
---@field Age int32
local FB1Packet_S_UpdateAgeByCheat = {}



---@class FB1Packet_S_UpdateAgeInfo : FB1PacketData
---@field EntityID FB1EntityId
---@field Age int32
---@field DeadAge int32
local FB1Packet_S_UpdateAgeInfo = {}



---@class FB1Packet_S_UpdateAttendenceAbsentDay : FB1PacketData
---@field EntityID FB1EntityId
---@field AttendenceDay int32
---@field AbsentDay int32
local FB1Packet_S_UpdateAttendenceAbsentDay = {}



---@class FB1Packet_S_UpdateBuffMap : FB1PacketData
---@field EntityID FB1EntityId
---@field BuffMap TMap<FName, FB1Buff>
---@field BuffTagMap TMap<FName, int32>
local FB1Packet_S_UpdateBuffMap = {}



---@class FB1Packet_S_UpdateCatOperatorAlert : FB1PacketData
local FB1Packet_S_UpdateCatOperatorAlert = {}


---@class FB1Packet_S_UpdateCharacterDataCache_Appearance : FB1PacketData
---@field DataCacheMap TMap<FB1EntityId, FB1AppearanceSetting>
local FB1Packet_S_UpdateCharacterDataCache_Appearance = {}



---@class FB1Packet_S_UpdateCharacterDataCache_Bio : FB1PacketData
---@field DataCacheMap TMap<FB1EntityId, FB1CharacterDataCache_Bio>
local FB1Packet_S_UpdateCharacterDataCache_Bio = {}



---@class FB1Packet_S_UpdateCharacterDataCache_Compact : FB1PacketData
---@field RequestID int64
---@field CacheList TArray<FB1CharacterDataCache_Compact>
local FB1Packet_S_UpdateCharacterDataCache_Compact = {}



---@class FB1Packet_S_UpdateCharacterDataCache_Emotion : FB1PacketData
---@field DataCacheMap TMap<FB1EntityId, FB1EmotionInfo>
local FB1Packet_S_UpdateCharacterDataCache_Emotion = {}



---@class FB1Packet_S_UpdateCharacterDataCache_Job : FB1PacketData
---@field DataCacheMap TMap<FB1EntityId, FB1CharacterDataCache_Job>
local FB1Packet_S_UpdateCharacterDataCache_Job = {}



---@class FB1Packet_S_UpdateCharacterDataCache_OnPossess : FB1PacketData
---@field PossessedCharacterDataCache FB1CharacterDataCache
---@field HouseholdDataCacheList TArray<FB1CharacterDataCache_PossessHousehold>
---@field RelationshipDataCacheList TArray<FB1CharacterDataCache_PossessRelationship>
local FB1Packet_S_UpdateCharacterDataCache_OnPossess = {}



---@class FB1Packet_S_UpdateCharacterDataCache_PossessBase : FB1PacketData
---@field RequestID int64
---@field CacheList TArray<FB1CharacterDataCache>
local FB1Packet_S_UpdateCharacterDataCache_PossessBase = {}



---@class FB1Packet_S_UpdateCharacterDataCache_PossessHousehold : FB1PacketData
---@field RequestID int64
---@field CacheList TArray<FB1CharacterDataCache_PossessHousehold>
local FB1Packet_S_UpdateCharacterDataCache_PossessHousehold = {}



---@class FB1Packet_S_UpdateCharacterDataCache_PossessRelationship : FB1PacketData
---@field RequestID int64
---@field CacheList TArray<FB1CharacterDataCache_PossessRelationship>
local FB1Packet_S_UpdateCharacterDataCache_PossessRelationship = {}



---@class FB1Packet_S_UpdateCharacterDataCache_PossessTick : FB1PacketData
---@field DataCache FB1CharacterDataCache_PossessTick
local FB1Packet_S_UpdateCharacterDataCache_PossessTick = {}



---@class FB1Packet_S_UpdateCharacterGroupType : FB1PacketData
---@field EntityID FB1EntityId
---@field CharacterGroupType EB1CharacterGroupType
local FB1Packet_S_UpdateCharacterGroupType = {}



---@class FB1Packet_S_UpdateCompanyInfo : FB1PacketData
---@field CompanyEntityId FB1EntityId
---@field CompanyInfo FB1CompanyInfo
local FB1Packet_S_UpdateCompanyInfo = {}



---@class FB1Packet_S_UpdateCraftingUI : FB1PacketData
---@field EntityID FB1EntityId
---@field bCloseUI boolean
---@field RecipeVMs TMap<FName, FB1CraftingRecipeVMs>
local FB1Packet_S_UpdateCraftingUI = {}



---@class FB1Packet_S_UpdateCurrency : FB1PacketData
---@field HouseholdEntityId FB1EntityId
---@field CharacterEntityId FB1EntityId
---@field CurrencyId FName
---@field bPrivateData boolean
---@field Value int64
---@field PlayWidgetEffectEntity FB1EntityId
---@field bIsSellInBuildMode boolean
---@field EffectLocation FVector
local FB1Packet_S_UpdateCurrency = {}



---@class FB1Packet_S_UpdateCurrentRabbitHoleId : FB1PacketData
---@field EntityID FB1EntityId
---@field RabbitHoleId FName
---@field RabbitHoleInteractionId FName
---@field InteractionStartTime int64
---@field ChoiceCardList TArray<FB1ChoiceCardTimeInfo>
local FB1Packet_S_UpdateCurrentRabbitHoleId = {}



---@class FB1Packet_S_UpdateCurrentSocialEventData : FB1PacketData
---@field SocialEventStateData FB1SocialEventStateData
---@field ForceUpateUI boolean
local FB1Packet_S_UpdateCurrentSocialEventData = {}



---@class FB1Packet_S_UpdateDataLayerState : FB1PacketData
---@field DataLayerPath FName
---@field DataLayerState FName
local FB1Packet_S_UpdateDataLayerState = {}



---@class FB1Packet_S_UpdateDataLog : FB1PacketData
---@field Day int32
---@field DailyLog FB1DailyLog
local FB1Packet_S_UpdateDataLog = {}



---@class FB1Packet_S_UpdateDecorationSpawnList : FB1PacketData
---@field PendingDecorationSpawnList TMap<FName, FB1DecorationSpawnInfoList>
local FB1Packet_S_UpdateDecorationSpawnList = {}



---@class FB1Packet_S_UpdateDynamicData : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
---@field VehicleDynamicDatas TArray<FB1VehicleDynamicData>
local FB1Packet_S_UpdateDynamicData = {}



---@class FB1Packet_S_UpdateEmotion : FB1PacketData
---@field EntityID FB1EntityId
---@field EmotionInfo FB1EmotionInfo
---@field EmotionInfoMap TMap<FName, FB1EmotionInfo>
---@field JoyfulBoostingEmotionId FName
---@field AdmitBoostingEmotionId FName
local FB1Packet_S_UpdateEmotion = {}



---@class FB1Packet_S_UpdateFoodMesh : FB1PacketData
---@field EntityID FB1EntityId
---@field RemainFoodValue int32
local FB1Packet_S_UpdateFoodMesh = {}



---@class FB1Packet_S_UpdateGamePause : FB1PacketData
---@field PauseReason EB1PauseReason
---@field bPause boolean
local FB1Packet_S_UpdateGamePause = {}



---@class FB1Packet_S_UpdateHighestEducation : FB1PacketData
---@field CharacterId FB1EntityId
---@field HighestEducationData FB1HighestEducationData
local FB1Packet_S_UpdateHighestEducation = {}



---@class FB1Packet_S_UpdateHopeLife : FB1PacketData
---@field EntityID FB1EntityId
---@field HopeLifeId FName
local FB1Packet_S_UpdateHopeLife = {}



---@class FB1Packet_S_UpdateHouseholdInfo : FB1PacketData
---@field HouseholdEntityId FB1EntityId
---@field HouseholdInfo FB1HouseholdInfo
local FB1Packet_S_UpdateHouseholdInfo = {}



---@class FB1Packet_S_UpdateInteractionQueue : FB1PacketData
---@field EntityID FB1EntityId
---@field UpdateQueueId int64
---@field InteractionQueue FB1InteractionQueueUIData
local FB1Packet_S_UpdateInteractionQueue = {}



---@class FB1Packet_S_UpdateInventory : FB1PacketData
---@field InventoryInfo FB1InventoryInfo
---@field UpdateReason EB1InventoryUpdateReason
local FB1Packet_S_UpdateInventory = {}



---@class FB1Packet_S_UpdateInventoryObject : FB1PacketData
---@field OwnerEntityId FB1EntityId
---@field TargetInventoryObjectInfo FB1InventoryEntityInfo
local FB1Packet_S_UpdateInventoryObject = {}



---@class FB1Packet_S_UpdateIsPregnant : FB1PacketData
---@field EntityID FB1EntityId
---@field IsPregnant boolean
local FB1Packet_S_UpdateIsPregnant = {}



---@class FB1Packet_S_UpdateJobExp : FB1PacketData
---@field EntityID FB1EntityId
---@field UpdatedJobExp int32
---@field UpdatedLevel int32
local FB1Packet_S_UpdateJobExp = {}



---@class FB1Packet_S_UpdateKarmaReport : FB1PacketData
---@field ZoICount int32
---@field GhostCount int32
---@field KarmaStepZoIList TMap<int32, FB1KarmaReportZoIInfoList>
local FB1Packet_S_UpdateKarmaReport = {}



---@class FB1Packet_S_UpdateLadderState : FB1PacketData
---@field EntityID FB1EntityId
---@field Phase EB1LadderAnimPhase
local FB1Packet_S_UpdateLadderState = {}



---@class FB1Packet_S_UpdateMainPerspectiveUI : FB1PacketData
---@field EntityID FB1EntityId
---@field bIsEnableDailyPopup boolean
---@field TitleId FString
---@field DescId FString
---@field MainPerspectiveId FName
local FB1Packet_S_UpdateMainPerspectiveUI = {}



---@class FB1Packet_S_UpdateObjectGrouping : FB1PacketData
---@field ParentEntityId FB1EntityId
---@field ChildEntityId FB1EntityId
---@field OccupiedSlotName FName
local FB1Packet_S_UpdateObjectGrouping = {}



---@class FB1Packet_S_UpdatePerspectiveUI : FB1PacketData
---@field EntityID FB1EntityId
local FB1Packet_S_UpdatePerspectiveUI = {}



---@class FB1Packet_S_UpdatePortrait : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
local FB1Packet_S_UpdatePortrait = {}



---@class FB1Packet_S_UpdatePregnancyBodyMorph : FB1PacketData
---@field EntityID FB1EntityId
---@field GroupName FName
---@field alpha float
local FB1Packet_S_UpdatePregnancyBodyMorph = {}



---@class FB1Packet_S_UpdatePrice : FB1PacketData
---@field EntityID FB1EntityId
---@field Price int64
local FB1Packet_S_UpdatePrice = {}



---@class FB1Packet_S_UpdateQuality : FB1PacketData
---@field EntityID FB1EntityId
---@field Quality EB1Quality
local FB1Packet_S_UpdateQuality = {}



---@class FB1Packet_S_UpdateRelationshipData : FB1PacketData
---@field SelfEntityId FB1EntityId
---@field TargetEntityId FB1EntityId
---@field SelfPrevStatData FB1RelationshipStatData
---@field TargetPrevStatData FB1RelationshipStatData
---@field SelfNewStatData FB1RelationshipStatData
---@field TargetNewStatData FB1RelationshipStatData
---@field SelfAdditionalStatData FB1RelationshipAdditionalStatData
---@field TargetAdditionalStatData FB1RelationshipAdditionalStatData
local FB1Packet_S_UpdateRelationshipData = {}



---@class FB1Packet_S_UpdateRelationshipDataList : FB1PacketData
---@field EntityID FB1EntityId
---@field bForceUI boolean
local FB1Packet_S_UpdateRelationshipDataList = {}



---@class FB1Packet_S_UpdateSeason : FB1PacketData
---@field SeasonType EB1SeasonType
local FB1Packet_S_UpdateSeason = {}



---@class FB1Packet_S_UpdateSiteDoorPermission : FB1PacketData
---@field SiteId FName
local FB1Packet_S_UpdateSiteDoorPermission = {}



---@class FB1Packet_S_UpdateSocialEventActionState : FB1PacketData
---@field ActionId FName
---@field State EB1SocialEventActionState
local FB1Packet_S_UpdateSocialEventActionState = {}



---@class FB1Packet_S_UpdateSocialEventScenarioFlag : FB1PacketData
---@field IsScenarioFlag boolean
local FB1Packet_S_UpdateSocialEventScenarioFlag = {}



---@class FB1Packet_S_UpdateSootValue : FB1PacketData
---@field EntityID FB1EntityId
---@field bActive boolean
---@field Value float
local FB1Packet_S_UpdateSootValue = {}



---@class FB1Packet_S_UpdateStateEntryUIInteraction : FB1PacketData
---@field UIStateData FB1StateUIData
local FB1Packet_S_UpdateStateEntryUIInteraction = {}



---@class FB1Packet_S_UpdateStateScheduleUI : FB1PacketData
---@field EntityID FB1EntityId
---@field ScheduleName FName
---@field bIsForAdding boolean
local FB1Packet_S_UpdateStateScheduleUI = {}



---@class FB1Packet_S_UpdateTimeScale : FB1PacketData
---@field timescale float
local FB1Packet_S_UpdateTimeScale = {}



---@class FB1Packet_S_UpdateTimeline : FB1PacketData
---@field EntityID FB1EntityId
---@field DayOfWeek EB1DayOfWeek
---@field Timeline FB1Timeline
---@field bIsBaseTimelines boolean
local FB1Packet_S_UpdateTimeline = {}



---@class FB1Packet_S_UpdateTrafficLightState : FB1PacketData
---@field LaneIndex int32
---@field Category EB1CityGraphCategory
---@field State EB1CityGraphLaneState
local FB1Packet_S_UpdateTrafficLightState = {}



---@class FB1Packet_S_UpdateTransform : FB1PacketData
---@field EntityID FB1EntityId
---@field Transform FTransform
local FB1Packet_S_UpdateTransform = {}



---@class FB1Packet_S_UpdateVehicleTransforms : FB1PacketData
---@field EntityIds TArray<FB1EntityId>
---@field Transforms TArray<FTransform>
---@field VehicleDynamicDatas TArray<FB1VehicleDynamicData>
---@field bNeedSynchronization boolean
local FB1Packet_S_UpdateVehicleTransforms = {}



---@class FB1Packet_S_UpdateWeather : FB1PacketData
---@field WeatherInfo FB1WeatherInfo
---@field bTransitionImmediately boolean
local FB1Packet_S_UpdateWeather = {}



---@class FB1Packet_S_UpdateWorkState : FB1PacketData
---@field CharacterId FB1EntityId
---@field WorkState EB1WorkState
local FB1Packet_S_UpdateWorkState = {}



---@class FB1Packet_S_UpdateWorkTicks : FB1PacketData
---@field CharacterId FB1EntityId
---@field StartWorkTicks int64
---@field EndWorkTicks int64
local FB1Packet_S_UpdateWorkTicks = {}



---@class FB1Packet_S_UpdateWorldDecorationSpawnCount : FB1PacketData
---@field WorldDecorationSpawnCountValue TMap<FName, FB1WorldDecorationSpawnCountDataList>
local FB1Packet_S_UpdateWorldDecorationSpawnCount = {}



---@class FB1Packet_S_UpdatetPreferenceData : FB1PacketData
---@field EntityID FB1EntityId
---@field PreferenceMap TMap<FName, boolean>
---@field PreferenceBuffMap TMap<FName, FB1PreferenceBuffData>
---@field MaxPreferenceCount int32
local FB1Packet_S_UpdatetPreferenceData = {}



---@class FB1Packet_S_WalkTo : FB1PacketData
---@field EntityID FB1EntityId
---@field Nodes TArray<FB1NavigationNode>
---@field CrossWalkNodes TArray<int32>
---@field AcceptanceRadius float
---@field PathId uint32
---@field Rotation FRotator
local FB1Packet_S_WalkTo = {}



---@class UB1PacketHubSystem : UObject
local UB1PacketHubSystem = {}


---@class UB1PacketSystemBase : UObject
local UB1PacketSystemBase = {}


