---@meta

---@class FMoviePipelinePostProcessPass
---@field bEnabled boolean
---@field Material TSoftObjectPtr<UMaterialInterface>
local FMoviePipelinePostProcessPass = {}



---@class UMovieGraphDeferredRenderPassNode : UMovieGraphImagePassBaseNode
---@field bOverride_SpatialSampleCount boolean
---@field bOverride_AntiAliasingMethod boolean
---@field bOverride_bDisableToneCurve boolean
---@field bOverride_bAllowOCIO boolean
---@field bOverride_ViewModeIndex boolean
---@field bOverride_bWriteAllSamples boolean
---@field bOverride_AdditionalPostProcessMaterials boolean
---@field SpatialSampleCount int32
---@field AntiAliasingMethod EAntiAliasingMethod
---@field bWriteAllSamples boolean
---@field bDisableToneCurve boolean
---@field bAllowOCIO boolean
---@field ViewModeIndex EViewModeIndex
---@field AdditionalPostProcessMaterials TArray<FMoviePipelinePostProcessPass>
local UMovieGraphDeferredRenderPassNode = {}



---@class UMovieGraphImagePassBaseNode : UMovieGraphRenderPassNode
---@field bOverride_ShowFlags boolean
---@field ShowFlags UMovieGraphShowFlags
local UMovieGraphImagePassBaseNode = {}



---@class UMovieGraphImageSequenceOutputNode : UMovieGraphFileOutputNode
---@field bOverride_OCIOConfiguration boolean
---@field bOverride_OCIOContext boolean
---@field OCIOConfiguration FOpenColorIODisplayConfiguration
---@field OCIOContext TMap<FString, FString>
local UMovieGraphImageSequenceOutputNode = {}



---@class UMovieGraphImageSequenceOutputNode_BMP : UMovieGraphImageSequenceOutputNode
local UMovieGraphImageSequenceOutputNode_BMP = {}


---@class UMovieGraphImageSequenceOutputNode_EXR : UMovieGraphImageSequenceOutputNode
---@field bOverride_Compression boolean
---@field Compression EEXRCompressionFormat
local UMovieGraphImageSequenceOutputNode_EXR = {}



---@class UMovieGraphImageSequenceOutputNode_JPG : UMovieGraphImageSequenceOutputNode
local UMovieGraphImageSequenceOutputNode_JPG = {}


---@class UMovieGraphImageSequenceOutputNode_MultiLayerEXR : UMovieGraphImageSequenceOutputNode_EXR
local UMovieGraphImageSequenceOutputNode_MultiLayerEXR = {}


---@class UMovieGraphImageSequenceOutputNode_PNG : UMovieGraphImageSequenceOutputNode
local UMovieGraphImageSequenceOutputNode_PNG = {}


---@class UMovieGraphPathTracerRenderPassNode : UMovieGraphImagePassBaseNode
---@field bOverride_SpatialSampleCount boolean
---@field bOverride_bDenoiser boolean
---@field bOverride_bDisableToneCurve boolean
---@field bOverride_bAllowOCIO boolean
---@field bOverride_bWriteAllSamples boolean
---@field bOverride_AdditionalPostProcessMaterials boolean
---@field SpatialSampleCount int32
---@field bDenoiser boolean
---@field bWriteAllSamples boolean
---@field bDisableToneCurve boolean
---@field bAllowOCIO boolean
---@field AdditionalPostProcessMaterials TArray<FMoviePipelinePostProcessPass>
local UMovieGraphPathTracerRenderPassNode = {}



---@class UMoviePipelineDeferredPassBase : UMoviePipelineImagePassBase
---@field bAccumulatorIncludesAlpha boolean
---@field bDisableMultisampleEffects boolean
---@field bUse32BitPostProcessMaterials boolean
---@field AdditionalPostProcessMaterials TArray<FMoviePipelinePostProcessPass>
---@field bRenderMainPass boolean
---@field bAddDefaultLayer boolean
---@field ActorLayers TArray<FActorLayer>
---@field DataLayers TArray<FSoftObjectPath>
---@field ActivePostProcessMaterials TArray<UMaterialInterface>
---@field StencilLayerMaterial UMaterialInterface
local UMoviePipelineDeferredPassBase = {}



---@class UMoviePipelineDeferredPass_DetailLighting : UMoviePipelineDeferredPassBase
local UMoviePipelineDeferredPass_DetailLighting = {}


---@class UMoviePipelineDeferredPass_LightingOnly : UMoviePipelineDeferredPassBase
local UMoviePipelineDeferredPass_LightingOnly = {}


---@class UMoviePipelineDeferredPass_PathTracer : UMoviePipelineDeferredPassBase
---@field bReferenceMotionBlur boolean
local UMoviePipelineDeferredPass_PathTracer = {}



---@class UMoviePipelineDeferredPass_ReflectionsOnly : UMoviePipelineDeferredPassBase
local UMoviePipelineDeferredPass_ReflectionsOnly = {}


---@class UMoviePipelineDeferredPass_Unlit : UMoviePipelineDeferredPassBase
local UMoviePipelineDeferredPass_Unlit = {}


---@class UMoviePipelineImagePassBase : UMoviePipelineRenderPass
local UMoviePipelineImagePassBase = {}


---@class UMoviePipelineImageSequenceOutputBase : UMoviePipelineOutputBase
local UMoviePipelineImageSequenceOutputBase = {}


---@class UMoviePipelineImageSequenceOutput_BMP : UMoviePipelineImageSequenceOutputBase
local UMoviePipelineImageSequenceOutput_BMP = {}


---@class UMoviePipelineImageSequenceOutput_EXR : UMoviePipelineImageSequenceOutputBase
---@field Compression EEXRCompressionFormat
---@field bMultilayer boolean
local UMoviePipelineImageSequenceOutput_EXR = {}



---@class UMoviePipelineImageSequenceOutput_JPG : UMoviePipelineImageSequenceOutputBase
local UMoviePipelineImageSequenceOutput_JPG = {}


---@class UMoviePipelineImageSequenceOutput_PNG : UMoviePipelineImageSequenceOutputBase
---@field bWriteAlpha boolean
local UMoviePipelineImageSequenceOutput_PNG = {}



---@class UMoviePipelineWaveOutput : UMoviePipelineOutputBase
---@field FileNameFormatOverride FString
local UMoviePipelineWaveOutput = {}



